# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/CpmPayload.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class CpmPayload(genpy.Message):
  _md5sum = "ba51d48efe3ae356d3d3b810a58290ca"
  _type = "etsi_its_cpm_ts_msgs/CpmPayload"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the payload of the CPM. 
#  *
#  * It shall include the following components: 
#  *
#  * @field managementContainer: the management container. 
#  *
#  * @field cpmContainers: the list of CPM containers, including its container type identifier and including either one or none of originatingVehicleContainer and/or originatingRsuContainer. 
#  *
# */
# CpmPayload ::= SEQUENCE {
#     managementContainer   ManagementContainer,
#     cpmContainers         ConstraintWrappedCpmContainers,
#     ...
# }
# ------------------------------------------------------------------------------

ManagementContainer management_container

ConstraintWrappedCpmContainers cpm_containers


================================================================================
MSG: etsi_its_cpm_ts_msgs/ManagementContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the management container of the CPM. 
#  * The management container provides basic information about the originating ITS-S, which are not specific to a specific type of station.
#  *
#  * It shall include the following components: 
#  *
#  * @field referenceTime: the reference time for all time related information in the CPM.
#  *
#  * @field messageRateRange: the planned or expected range of the CPM generation rate.
#  *
#  * @field segmentationInfo: information regarding the message segmentation on facility layer.
#  *
#  * @field referencePosition: the reference position for all position related information in the CPM.
#  *
# */
# ManagementContainer ::= SEQUENCE {
#     referenceTime      TimestampIts,
#     referencePosition  ReferencePosition,
#     segmentationInfo   MessageSegmentationInfo OPTIONAL,
#     messageRateRange   MessageRateRange OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

TimestampIts reference_time

ReferencePosition reference_position

MessageSegmentationInfo segmentation_info
bool segmentation_info_is_present

MessageRateRange message_rate_range
bool message_rate_range_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/TimestampIts
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
#  * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
#  * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
#  *  i.e. it is not altered by leap seconds, which occur in UTC.
#  * 
#  * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
#  * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
#  * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
#  * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
#  * further 5 leap seconds have been inserted in UTC.
#  * 
#  * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
#  * which includes one leap second insertion since the ITS epoch.
#  * @unit: 0,001 s
#  * @category: Basic information
#  * @revision: Description revised in in V2.1.1
#  */
# TimestampIts ::= INTEGER (0..4398046511103)
# ------------------------------------------------------------------------------

uint64 value
uint64 MIN = 0
uint64 MAX = 4398046511103


================================================================================
MSG: etsi_its_cpm_ts_msgs/ReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * A position within a geographic coordinate system together with a confidence ellipse. 
#  *
#  * It shall include the following components: 
#  *
#  * @field latitude: the latitude of the geographical point.
#  *
#  * @field longitude: the longitude of the geographical point.
#  *
#  * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
#  *
#  * @field altitude: the altitude and an altitude accuracy of the geographical point.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref ReferencePositionWithConfidence instead. 
#  * @category: GeoReference information
#  * @revision: description updated in V2.1.1
#  */
# ReferencePosition ::= SEQUENCE {
#     latitude                     Latitude,
#     longitude                    Longitude,
#     positionConfidenceEllipse    PosConfidenceEllipse,
#     altitude                     Altitude
# }
# ------------------------------------------------------------------------------

Latitude latitude

Longitude longitude

PosConfidenceEllipse position_confidence_ellipse

Altitude altitude


================================================================================
MSG: etsi_its_cpm_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
#  * in south hemisphere.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
#  * - `0` is used for the latitude of the equator,
#  * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
#  * - `900 000 001` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Editorial update in V2.1.1
#  */
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001


================================================================================
MSG: etsi_its_cpm_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
#  * to the east or to the west of the prime meridian.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
#  * - `0` to indicate the prime meridian,
#  * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
#  * - `1 800 000 001` when the information is unavailable.
#  *
#  * The value -1 800 000 000 shall not be used. 
#  * 
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001


================================================================================
MSG: etsi_its_cpm_ts_msgs/PosConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  *
#  * @category GeoReference information
#  * @revision: V1.3.1
#  */
# PosConfidenceEllipse ::= SEQUENCE {
#     semiMajorConfidence     SemiAxisLength,
#     semiMinorConfidence     SemiAxisLength,
#     semiMajorOrientation    HeadingValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_confidence

SemiAxisLength semi_minor_confidence

HeadingValue semi_major_orientation


================================================================================
MSG: etsi_its_cpm_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_cpm_ts_msgs/Altitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the altitude and confidence level of an altitude information in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field altitudeValue: altitude of a geographical point.
#  *
#  * @field altitudeConfidence: confidence level of the altitudeValue.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref AltitudeWithConfidence instead. 
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Altitude ::= SEQUENCE {
#     altitudeValue         AltitudeValue,
#     altitudeConfidence    AltitudeConfidence
# }
# ------------------------------------------------------------------------------

AltitudeValue altitude_value

AltitudeConfidence altitude_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the altitude value in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `-100 000` if the altitude is equal to or less than -1 000 m,
#  * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
#  * - `800 000` if the altitude  greater than 7 999,99 m,
#  * - `800 001` if the information is not available.
#  *
#  * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
#  */
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001


================================================================================
MSG: etsi_its_cpm_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/MessageSegmentationInfo
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides information about a message with respect to the segmentation process at the sender.
#  *
#  * It shall include the following components: 
#  * 
#  * @field totalMsgNo: indicates the total number of messages that has been used on the transmitter side to encode the information.
#  *
#  * @field thisMsgNo: indicates the position of the message within of the total set of messages.
#  *
#  * @category: Communication information
#  * @revision: Created in V2.1.1
#  */
# MessageSegmentationInfo ::= SEQUENCE {
#     totalMsgNo  CardinalNumber3b,
#     thisMsgNo   OrdinalNumber3b
#     }
# ------------------------------------------------------------------------------

CardinalNumber3b total_msg_no

OrdinalNumber3b this_msg_no


================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber3b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents a cardinal number that counts the size of a set. 
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CardinalNumber3b ::= INTEGER(1..8)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/OrdinalNumber3b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents an ordinal number that indicates the position of an element in a set. 
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# OrdinalNumber3b ::= INTEGER(1..8) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/MessageRateRange
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the planned or expected range of the message generation rate.
#  *
#  * It shall include the following components: 
#  *
#  * @field messageRateMin: the minimum planned or expected message rate.
#  *
#  * @field messageRateMax: the maximum planned or expected message rate.
#  *
# */
# MessageRateRange::= SEQUENCE{
#    messageRateMin   MessageRateHz,
#    messageRateMax   MessageRateHz
# }
# ------------------------------------------------------------------------------

MessageRateHz message_rate_min

MessageRateHz message_rate_max


================================================================================
MSG: etsi_its_cpm_ts_msgs/MessageRateHz
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a message rate.
#  *
#  * @field mantissa: indicates the mantissa.
#  *
#  * @field exponent: indicates the exponent.
#  *
#  * The specified message rate is: mantissa*(10^exponent) 
#  *
#  * @unit: Hz
#  * @category: Communication information
#  * @revision: Created in V2.1.1
#  */
# MessageRateHz::= SEQUENCE {
#     mantissa    INTEGER (1..100),
#     exponent    INTEGER (-5..2)
#     }
# ------------------------------------------------------------------------------

uint8 mantissa
uint8 MANTISSA_MIN = 1
uint8 MANTISSA_MAX = 100

int8 exponent
int8 EXPONENT_MIN = -5
int8 EXPONENT_MAX = 2


================================================================================
MSG: etsi_its_cpm_ts_msgs/ConstraintWrappedCpmContainers
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a list of CPM containers, each with their type identifier with an additional constraint. 
# */
# ConstraintWrappedCpmContainers ::= WrappedCpmContainers
# ------------------------------------------------------------------------------

WrappedCpmContainers value


================================================================================
MSG: etsi_its_cpm_ts_msgs/WrappedCpmContainers
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a list of CPM containers, each with their type identifier. 
# */
# WrappedCpmContainers::= SEQUENCE SIZE(1..8,...) OF WrappedCpmContainer 
# ------------------------------------------------------------------------------

WrappedCpmContainer[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/WrappedCpmContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a CPM container preceded by its type identifier and a lenght indicator.
#  *
#  * It shall include the following components: 
#  *
#  * @field containerId: the identifier of the container type.
#  *
#  * @field containerData: the container content consistent with the container type.
#  *
# */
# WrappedCpmContainer ::= SEQUENCE {
#    containerId     CPM-CONTAINER-ID-AND-TYPE.&id( {CpmContainers} ),
#    containerData   CPM-CONTAINER-ID-AND-TYPE.&Type( {CpmContainers}{@containerId} )
# }
# ------------------------------------------------------------------------------

CpmContainerId container_id


OriginatingVehicleContainer container_data_originating_vehicle_container
uint8 CHOICE_CONTAINER_DATA_ORIGINATING_VEHICLE_CONTAINER = 1

OriginatingRsuContainer container_data_originating_rsu_container
uint8 CHOICE_CONTAINER_DATA_ORIGINATING_RSU_CONTAINER = 2

SensorInformationContainer container_data_sensor_information_container
uint8 CHOICE_CONTAINER_DATA_SENSOR_INFORMATION_CONTAINER = 3

PerceptionRegionContainer container_data_perception_region_container
uint8 CHOICE_CONTAINER_DATA_PERCEPTION_REGION_CONTAINER = 4

PerceivedObjectContainer container_data_perceived_object_container
uint8 CHOICE_CONTAINER_DATA_PERCEIVED_OBJECT_CONTAINER = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/CpmContainerId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the identifier of the container type. 
#  *
# */
# CpmContainerId ::= INTEGER (1..16)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 16


================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingVehicleContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the Originating Vehicle Container
#  *
#  * It shall include the following components: 
#  *
#  * @field orientationAngle: the angle and angle accuracy of the absolute orientation of the disseminating vehicle in the WGS84 coordinate system with respect to true North.
#  *
#  * @field pitchAngle: the optional angle and angle accuracy between the ground plane and the current orientation of the vehicle's x-axis with respect to the ground plane about the y-axis according to the ISO 8855.
#  *
#  * @field rollAngle: the optional angle and angle accuracy between the ground plane and the current orientation of a vehicle's y-axis with respect to the ground plane about the x-axis according to the ISO 8855
#  *
#  * @field trailerData: information about the trailer dimensions and orientation in case a trailer is present.
#  * 
# */
# OriginatingVehicleContainer ::= SEQUENCE {
#     orientationAngle   Wgs84Angle,
#     pitchAngle         CartesianAngle OPTIONAL,
#     rollAngle          CartesianAngle OPTIONAL,
#     trailerDataSet     TrailerDataSet OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

Wgs84Angle orientation_angle

CartesianAngle pitch_angle
bool pitch_angle_is_present

CartesianAngle roll_angle
bool roll_angle_is_present

TrailerDataSet trailer_data_set
bool trailer_data_set_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84Angle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an angular component along with a confidence value in the WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: the angle value, which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the confidence value associated to the angle value.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# Wgs84Angle ::= SEQUENCE {
#     value         Wgs84AngleValue,
#     confidence    Wgs84AngleConfidence
# }
# ------------------------------------------------------------------------------

Wgs84AngleValue value

Wgs84AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,
#  * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the confidence value is not available.
#  *
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: The angle value which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: The confidence value associated to the provided value.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
#  * a right-hand local coordinate system from the abscissa.
#  *
#  * The value shall be set to: 
#  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
#  * - `36001` if the accuracy information is not available.
#  *
#  * The value 3600 shall not be used. 
#  * 
#  * @unit 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
#  * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the accuracy information is not available.
#  *
#  * @unit: 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerDataSet
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents a list of trailer data.
#  * 
# */
# TrailerDataSet::= SEQUENCE SIZE(1..8,...) OF TrailerData (WITH COMPONENTS {... ,frontOverhang ABSENT, rearOverhang ABSENT, trailerWidth ABSENT}) 
# ------------------------------------------------------------------------------

TrailerData[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF provides detailed information about an attached trailer.
#  *
#  * It shall include the following components: 
#  *
#  * @field refPointId: identifier of the reference point of the trailer.
#  *
#  * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
#  * vehicle Reference Point.
#  *
#  * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
#  * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
#  * is not overhanging to the front with respect to the trailer reference point.
#  *
#  * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
#  * trailer Reference Point indicated by the refPointID.
#  *
#  * @field trailerWidth: optional width of the trailer.
#  *
#  * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
#  * direction of the ISO 8855 [21] coordinate system centered on the trailer) and the direction of
#  * the segment having as end points the reference point of the trailer and the reference point of
#  * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
#  * xy, described in the local Cartesian coordinate system of the trailer. The
#  * angle is measured with negative values considering the trailer orientation turning clockwise
#  * starting from the segment direction. The angle value accuracy is provided with the
#  * confidence level of 95 %.
#  *
#  * @category: Vehicle information
#  * @revision: Created in V2.1.1
# */
# TrailerData ::= SEQUENCE { 
#     refPointId          Identifier1B,
#     hitchPointOffset    StandardLength1B, 
#     frontOverhang       StandardLength1B OPTIONAL, 
#     rearOverhang        StandardLength1B OPTIONAL, 
#     trailerWidth        VehicleWidth OPTIONAL,
#     hitchAngle          CartesianAngle,
#     ...
# }
# ------------------------------------------------------------------------------

Identifier1B ref_point_id

StandardLength1B hitch_point_offset

StandardLength1B front_overhang
bool front_overhang_is_present

StandardLength1B rear_overhang
bool rear_overhang_is_present

VehicleWidth trailer_width
bool trailer_width_is_present

CartesianAngle hitch_angle


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents length as a measure of distance between points or as a dimension of an object. 
#  *
#  * @unit: 0,1 metre
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# StandardLength1B::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
# 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
#  * - `61` indicates that the vehicle width is greater than 6,0 metres,
#  * - `62` indicates that the information in unavailable.
#  * 
#  * @unit: 0,1 metre
#  * @category: Vehicle information 
#  * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
#  */
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62


================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingRsuContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the Originating RSU Container.
#  *
#  * It shall include the following components: 
#  *
#  * @field mapReference: identifies the MAPEM containing the topology information reference in the Perceived Object Container
#  * 
# */
# OriginatingRsuContainer ::= SEQUENCE{
#     mapReference    MapReference OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

MapReference map_reference
bool map_reference_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
#  *
#  * The following options are provided:
#  * 
#  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
#  * 
#  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for a road segment
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the road segment.
#  *
#  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cpm_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the intersection
#  *
#  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformationContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the Sensor Information Container as a list of information objects about the sensors or data fusion systems from which the station provides information about detected objects.
# */
# SensorInformationContainer ::= SEQUENCE SIZE(1..128, ...) OF SensorInformation
# ------------------------------------------------------------------------------

SensorInformation[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 128


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the characteristics of a single sensor or data fusion system.
#  *
#  * It shall include the following components: 
#  *
#  * @field sensorId: identifier of the sensor or data fusion system used to relate the perceived object in the Perceived Object Container to the sensor that detected it.
#  * this identifier shall uniquely identify the sensor inside the CPM, but may be changed from one CPM to the next.
#  *
#  * @field sensorType: the type of the sensor.
#  *
#  * @field perceptionRegionShape: the perception region of the sensor.
#  *
#  * @field perceptionRegionConfidence: the homogeneous perception region confidence that can be assumed for the entire perception region shape of this sensor. 
#  *
#  * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
#  *
# */
# SensorInformation ::= SEQUENCE {
#     sensorId          		    Identifier1B,
#     sensorType        		    SensorType,
#     perceptionRegionShape		Shape OPTIONAL,
#     perceptionRegionConfidence  ConfidenceLevel OPTIONAL,
#     shadowingApplies            BOOLEAN,
#    ...
# }
# ------------------------------------------------------------------------------

Identifier1B sensor_id

SensorType sensor_type

Shape perception_region_shape
bool perception_region_shape_is_present

ConfidenceLevel perception_region_confidence
bool perception_region_confidence_is_present

bool shadowing_applies


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the type of sensor.
#  * 
#  * The value shall be set to:
#  * - 0  `undefined`         - in case the sensor type is undefined. 
#  * - 1  `radar`             - in case the sensor is a radar,
#  * - 2  `lidar`             - in case the sensor is a lidar,
#  * - 3  `monovideo`         - in case the sensor is mono video,
#  * - 4  `stereovision`      - in case the sensor is stereo vision,
#  * - 5  `nightvision`       - in case the sensor is night vision,
#  * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
#  * - 7  `pmd`               - in case the sensor is photonic mixing device,
#  * - 8  `inductionLoop`     - in case the sensor is an induction loop,
#  * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
#  * - 10 `uwb`               - in case the sensor is ultra wide band,
#  * - 11 `acoustic`          - in case the sensor is acoustic,
#  * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
#  * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
#  * - 14-31                  - are reserved for future usage.
#  *
#  * @category: Sensing Information
#  * @revision: created in V2.1.1
# */
# SensorType ::= INTEGER {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (0..31)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 UNDEFINED = 0
uint8 RADAR = 1
uint8 LIDAR = 2
uint8 MONOVIDEO = 3
uint8 STEREOVISION = 4
uint8 NIGHTVISION = 5
uint8 ULTRASONIC = 6
uint8 PMD = 7
uint8 INDUCTION_LOOP = 8
uint8 SPHERICAL_CAMERA = 9
uint8 UWB = 10
uint8 ACOUSTIC = 11
uint8 LOCAL_AGGREGATION = 12
uint8 ITS_AGGREGATION = 13


================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the definition of a geographical area or volume, based on different options.
#  *
#  * It is a choice of the following components: 
#  *
#  * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
#  *
#  * @field circular: definition of an area of circular shape or a right circular cylinder.
#  *
#  * @field polygonal: definition of an area of polygonal shape or a right prism.
#  *
#  * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
#  *
#  * @field radial: definition of a radial shape.
#  *
#  * @field radialList: definition of list of radial shapes.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
#  */
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
#  *
#  * It shall include the following components: 
#  * 
#  * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
#  *
#  * @field semiLength: represents half the length of the rectangle.
#  * 
#  * @field semiBreadth: represents half the breadth of the rectangle.
#  *
#  * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
#  *
#  * @category GeoReference information
#  * @revision: created in V2.1.1
#  */
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
#  *
#  * It shall include the following components: 
#  *
#  * @field xCoordinate: the X coordinate value.
#  *
#  * @field yCoordinate: the Y coordinate value.
#  *
#  * @field zCoordinate: the optional Z coordinate value.
#  * 
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
#  *
#  * The value shall be set to:
#  * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
#  * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
#  *
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
#  *
#  * @unit: 0,1 metre
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * 
#  * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
#  *
#  * It shall include the following components: 
#  * 
#  * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
#  * If this component is absent, the externally specified reference position represents the shape's reference point. 
#  *
#  * @field radius: the radius of the circular area.
#  *
#  * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
#  *
#  * 
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
#  */
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the shape of a polygonal area or of a right prism.
#  *
#  * It shall include the following components: 
#  *
#  * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
#  * If this component is absent, the externally specified reference position represents the shape's reference point. 
#  *
#  * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
#  * All nodes of the polygon shall be considered relative to the shape's reference point.
#  *
#  * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
#  * 
#  * @category GeoReference information
#  * @revision: created in V2.1.1
#  *
#  */
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
uint8 POLYGON_MIN_SIZE = 3
uint8 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF shall contain a list of DF @ref CartesianPosition3d.
#  * 
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------

CartesianPosition3d[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * 
#  * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
#  *
#  * It shall include the following components: 
#  * 
#  * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
#  * If this component is absent, the externally specified reference position represents the shape's  reference point. 
#  *
#  * @field semiMajorAxisLength: half length of the major axis of the ellipse.
#  * 
#  * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
#  *
#  * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
#  * 
#  * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a radial shape. The triangular or cone-shaped volume is
#  * constructed by sweeping the provided range about the reference point  between a horizontal start 
#  * and a horizontal end angle in positive angular direction of the WGS84
#  * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
#  * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
#  * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
#  * above intersections).
#  *
#  * It shall include the following components:
#  * 
#  * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
#  * If this component is absent, the externally specified reference position represents the shape's  reference point. 
#  *
#  * @field range: the radial range of the shape from the shape's reference point. 
#  *
#  * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
#  * shape's horizontal opening angle in positive angular direction with respect to the 
#  * WGS84 coordinate system.
#  *
#  * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
#  * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
#  * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system. 
#  *
#  * @category GeoReference information
#  * @revision: created in V2.1.1
# */
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a list of radial shapes. 
#  *
#  * It shall include the following components:
# 
#  * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
#  * 
#  * @field xCoordinate: the x-coordinate of the offset point.
#  *
#  * @field yCoordinate: the y-coordinate of the offset point.
#  *
#  * @field zCoordinate: the optional z-coordinate of the offset point.
#  *
#  * @field radialShapesList: the list of radial shape details.
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */ 
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
#  *
#  * The value shall be set to:
#  * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
#  * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
#  *
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * The DF contains a list of @ref RadialShapeDetails.
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------

RadialShapeDetails[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a radial shape details. The triangular or cone-shaped volume is
#  * constructed by sweeping the provided range about the reference point  or about the offset
#  * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
#  * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
#  * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
#  * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
#  * above intersections).
#  *
#  * It shall include the following components:
#  * 
#  * @field range: the radial range of the sensor from the reference point or sensor point offset. 
#  *
#  * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
#  * shape's horizontal opening angle in positive angular direction.
#  *
#  * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
#  * opening angle in positive angular direction.
#  *
#  * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system. 
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a confidence level in percentage.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
#  * - `101`                   : in case the confidence level is not available.
#  *
#  * @unit Percent 
#  * @category: Basic information 
#  * @revision: Created in V2.1.1 
# */
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegionContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the Perception Region Container as a list of perception region information objects. 
# */
# PerceptionRegionContainer ::= SEQUENCE SIZE(1..256, ...) OF PerceptionRegion
# ------------------------------------------------------------------------------

PerceptionRegion[] array
uint16 MIN_SIZE = 1
uint16 MAX_SIZE = 256


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegion
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the actual perception capabilities available to the transmitting ITS-S, offering additional (often dynamic) details to the information provided in the sensor information container.
#  *
#  * It shall include the following components: 
# 
#  * @field measurementDeltaTime: difference between the time of estimation of the perception region and the reference time. Positive values indicates that the provided information refers to a point in time after the reference time.
#  *
#  * @field perceptionRegionConfidence: the perception confidence.
#  *
#  * @field perceptionRegionShape: specification of the shape of the perception region.
#  *
#  * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
#  *
#  * @field sensorIdList: the optional list of identifiers of the sensors which are involved in perceiving the region.
#  *
#  * @field numberOfPerceivedObjects: the optional number of perceived objects contained in the perception region specified in the component perceptionRegionShape. 
#  *
#  * @field perceivedObjectIds: the optional list of identifiers of the objects specified in the Perceived Object Container that are contained in the perception region specified in the component perceptionRegionShape.
#  *
# */
# PerceptionRegion ::= SEQUENCE {
#     measurementDeltaTime         DeltaTimeMilliSecondSigned,     
#     perceptionRegionConfidence   ConfidenceLevel,
#     perceptionRegionShape        Shape, 
#     shadowingApplies             BOOLEAN,
#     sensorIdList                 SequenceOfIdentifier1B OPTIONAL,
#     numberOfPerceivedObjects     CardinalNumber1B OPTIONAL,
#     perceivedObjectIds           PerceivedObjectIds OPTIONAL,
# 	...
# }
# ------------------------------------------------------------------------------

DeltaTimeMilliSecondSigned measurement_delta_time

ConfidenceLevel perception_region_confidence

Shape perception_region_shape

bool shadowing_applies

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

CardinalNumber1B number_of_perceived_objects
bool number_of_perceived_objects_is_present

PerceivedObjectIds perceived_object_ids
bool perceived_object_ids_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaTimeMilliSecondSigned
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a signed difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `-2048` for time values equal to or less than -2,048 s,
#  * - `n` (`n > -2048` and `n < 2047`) to indicate a time value equal to or less than n x 0,001 s, and greater than (n-1) x 0,001 s,
#  * - `2047` for time values greater than 2,046 s
#  *
#  * @unit: 0,001 s
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# DeltaTimeMilliSecondSigned ::= INTEGER (-2048..2047)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -2048
int16 MAX = 2047


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfIdentifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * The DF contains a list of DE @ref Identifier1B.
#  *
#  * @category: Basic information
#  * @revision: created in V2.1.1
# */
# SequenceOfIdentifier1B ::= SEQUENCE SIZE(1..128, ...) OF Identifier1B
# ------------------------------------------------------------------------------

Identifier1B[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 128


================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents a cardinal number that counts the size of a set. 
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CardinalNumber1B ::= INTEGER(0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectIds
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents a list of identifiers of perceived objects. 
# */
# PerceivedObjectIds::= SEQUENCE SIZE(0..255, ...) OF Identifier2B
# ------------------------------------------------------------------------------

Identifier2B[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  represents the Perceived Object Container 
#  *
#  * It shall include the following components: 
#  *
#  * @field numberOfPerceivedObjects: the total number of perceived objects at the time of generating the message. 
#  *
#  * @field perceivedObjects: the list of perceived objects.
#  *
# */
# PerceivedObjectContainer ::= SEQUENCE {
#     numberOfPerceivedObjects    CardinalNumber1B,
#     perceivedObjects            PerceivedObjects,
#     ...
# }
# ------------------------------------------------------------------------------

CardinalNumber1B number_of_perceived_objects

PerceivedObjects perceived_objects


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjects
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** @brief Perceived Objects
#  * This DF provides a list of perceived objects represented in the coordinate system in which the y-axis corresponds to the North direction, the x-axis to the East direction, and the z- axis to the vertical direction.
# */
# PerceivedObjects::= SEQUENCE SIZE(0..255, ...) OF PerceivedObject (WITH COMPONENTS {... ,objectId PRESENT})
# ------------------------------------------------------------------------------

PerceivedObject[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObject
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF contains information about a perceived object including its kinematic state and attitude vector in a pre-defined coordinate system and with respect to a reference time.
#  * 
#  * It shall include the following components: 
#  *
#  * @field objectId: optional identifier assigned to a detected object.
#  *
#  * @field measurementDeltaTime: the time difference from a reference time to the time of the  measurement of the object. 
#  * Negative values indicate that the provided object state refers to a point in time before the reference time.
#  *
#  * @field position: the position of the geometric centre of the object's bounding box within the pre-defined coordinate system.
#  *
#  * @field velocity: the velocity vector of the object within the pre-defined coordinate system.
#  *
#  * @field acceleration: the acceleration vector of the object within the pre-defined coordinate system.
#  *
#  * @field angles: optional Euler angles of the object bounding box at the time of measurement. 
#  * 
#  * @field zAngularVelocity: optional angular velocity of the object around the z-axis at the time of measurement.
#  * The angular velocity is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule.
#  *
#  * @field lowerTriangularCorrelationMatrices: optional set of lower triangular correlation matrices for selected components of the provided kinematic state and attitude vector.
#  *
#  * @field objectDimensionZ: optional z-dimension of object bounding box. 
#  * This dimension shall be measured along the direction of the z-axis after all the rotations have been applied. 
#  *
#  * @field objectDimensionY: optional y-dimension of the object bounding box. 
#  * This dimension shall be measured along the direction of the y-axis after all the rotations have been applied. 
#  *
#  * @field objectDimensionX: optional x-dimension of object bounding box.
#  * This dimension shall be measured along the direction of the x-axis after all the rotations have been applied.
#  * 
#  * @field objectAge: optional age of the detected and described object, i.e. the difference in time between the moment 
#  * it has been first detected and the reference time of the message. Value `1500` indicates that the object has been observed for more than 1.5s.
#  *
#  * @field objectPerceptionQuality: optional confidence associated to the object. 
#  *
#  * @field sensorIdList: optional list of sensor-IDs which provided the measurement data. 
#  *
#  * @field classification: optional classification of the described object
#  *
#  * @field matchedPosition: optional map-matched position of an object.
#  *
#  * @category Sensing information
#  * @revision: created in V2.1.1
#  */
# PerceivedObject ::= SEQUENCE {
#     objectId                                          Identifier2B OPTIONAL,
#     measurementDeltaTime                              DeltaTimeMilliSecondSigned,
#     position                                          CartesianPosition3dWithConfidence, 
#     velocity                                          Velocity3dWithConfidence OPTIONAL,
#     acceleration                                      Acceleration3dWithConfidence OPTIONAL,
#     angles                                            EulerAnglesWithConfidence OPTIONAL,
#     zAngularVelocity                                  CartesianAngularVelocityComponent OPTIONAL,
#     lowerTriangularCorrelationMatrices                LowerTriangularPositiveSemidefiniteMatrices OPTIONAL,
#     objectDimensionZ                                  ObjectDimension OPTIONAL,
#     objectDimensionY                                  ObjectDimension OPTIONAL,
#     objectDimensionX                                  ObjectDimension OPTIONAL,
#     objectAge                                         DeltaTimeMilliSecondSigned (0..2047) OPTIONAL,
#     objectPerceptionQuality                           ObjectPerceptionQuality OPTIONAL,
#     sensorIdList                                      SequenceOfIdentifier1B OPTIONAL,
#     classification                                    ObjectClassDescription OPTIONAL,
#     mapPosition                                       MapPosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

Identifier2B object_id
bool object_id_is_present

DeltaTimeMilliSecondSigned measurement_delta_time

CartesianPosition3dWithConfidence position

Velocity3dWithConfidence velocity
bool velocity_is_present

Acceleration3dWithConfidence acceleration
bool acceleration_is_present

EulerAnglesWithConfidence angles
bool angles_is_present

CartesianAngularVelocityComponent z_angular_velocity
bool z_angular_velocity_is_present

LowerTriangularPositiveSemidefiniteMatrices lower_triangular_correlation_matrices
bool lower_triangular_correlation_matrices_is_present

ObjectDimension object_dimension_z
bool object_dimension_z_is_present

ObjectDimension object_dimension_y
bool object_dimension_y_is_present

ObjectDimension object_dimension_x
bool object_dimension_x_is_present

DeltaTimeMilliSecondSigned object_age
bool object_age_is_present
uint16 OBJECT_AGE_MIN = 0
uint16 OBJECT_AGE_MAX = 2047

ObjectPerceptionQuality object_perception_quality
bool object_perception_quality_is_present

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

ObjectClassDescription classification
bool classification_is_present

MapPosition map_position
bool map_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a  position in a two- or three-dimensional cartesian coordinate system with an associated confidence level for each coordinate.
#  *
#  * It shall include the following components: 
#  *
#  * @field xCoordinate: the X coordinate value with the associated confidence level.
#  *
#  * @field yCoordinate: the Y coordinate value with the associated confidence level.
#  *
#  * @field zCoordinate: the optional Z coordinate value with the associated confidence level.
#  * 
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# CartesianPosition3dWithConfidence::= SEQUENCE{    
#     xCoordinate    CartesianCoordinateWithConfidence, 
#     yCoordinate    CartesianCoordinateWithConfidence, 
#     zCoordinate    CartesianCoordinateWithConfidence OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianCoordinateWithConfidence x_coordinate

CartesianCoordinateWithConfidence y_coordinate

CartesianCoordinateWithConfidence z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a coordinate along with a confidence value in a cartesian reference system.
#  *
#  * It shall include the following components: 
#  * 
#  * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
#  * 
#  * @field confidence: the coordinate confidence value associated to the provided value.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinateWithConfidence ::= SEQUENCE {
#     value         CartesianCoordinateLarge,
#     confidence    CoordinateConfidence
# }
# ------------------------------------------------------------------------------

CartesianCoordinateLarge value

CoordinateConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
#  *
#  * The value shall be set to:
#  * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
#  * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
#  *  
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinateLarge::= INTEGER{ 
#     negativeOutOfRange (-131072),
#     positiveOutOfRange (131071)
# } (-131072..131071)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131072
int32 MAX = 131071
int32 NEGATIVE_OUT_OF_RANGE = -131072
int32 POSITIVE_OUT_OF_RANGE = 131071


================================================================================
MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
#  * - `4095` if the confidence value is greater than 40,94 metres,
#  * - `4096` if the confidence value is not available.
#  *
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CoordinateConfidence ::= INTEGER {
#     outOfRange            (4095),
#     unavailable           (4096) 
# } (1..4096)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 4096
uint16 OUT_OF_RANGE = 4095
uint16 UNAVAILABLE = 4096


================================================================================
MSG: etsi_its_cpm_ts_msgs/Velocity3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a velocity vector with associated confidence value.
#  *
#  * The following options are available:
#  * 
#  * @field polarVelocity: the representation of the velocity vector in a polar or cylindrical coordinate system. 
#  * 
#  * @field cartesianVelocity: the representation of the velocity vector in a cartesian coordinate system.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# Velocity3dWithConfidence::= CHOICE{
#     polarVelocity          VelocityPolarWithZ, 
#     cartesianVelocity      VelocityCartesian
# }
# ------------------------------------------------------------------------------

uint8 choice

VelocityPolarWithZ polar_velocity
uint8 CHOICE_POLAR_VELOCITY = 0

VelocityCartesian cartesian_velocity
uint8 CHOICE_CARTESIAN_VELOCITY = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a velocity vector in a polar or cylindrical coordinate system.
#  *
#  * It shall include the following components: 
#  * 
#  * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
#  * 
#  * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
#  *
#  * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# VelocityPolarWithZ::= SEQUENCE {
#     velocityMagnitude    Speed, 
#     velocityDirection    CartesianAngle,
#     zVelocity            VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------

Speed velocity_magnitude

CartesianAngle velocity_direction

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the speed and associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field speedValue: the speed value.
#  * 
#  * @field speedConfidence: the confidence value of the speed value.
#  *
#  * @category: Kinematic information
#  * @revision: V1.3.1
#  */
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
#  *
#  * The value shall be set to:
#  * - `0` in a standstill situation.
#  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
#  * - `16 382` for speed values greater than 163,81 m/s,
#  * - `16 383` if the speed accuracy information is not available.
#  * 
#  * @note: the definition of standstill is out of scope of the present document.
#  *
#  * @unit: 0,01 m/s
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
# */
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383


================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
#  * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
#  * - `127` if the confidence value information is not available.
#  *  
#  * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the speed value may be valid and used by the application.
#  * 
#  * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
#  * and therefore cannot be trusted. Such is not useful for the application.
#  *
#  * @unit: 0,01 m/s
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1 
#  */
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a component of the velocity vector and the associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field value: the value of the component.
#  * 
#  * @field confidence: the confidence value of the value.
#  *
#  * @category: Kinematic information
#  * @revision: V2.1.1
#  */
# VelocityComponent ::= SEQUENCE {
#     value         VelocityComponentValue,
#     confidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------

VelocityComponentValue value

SpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the value of a velocity component in a defined coordinate system.
#  *
#  * The value shall be set to:
#  * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
#  * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
#  * - `16 382` for velocity values equal to or greater than 163,81 m/s,
#  * - `16 383` if the velocity information is not available.
#  * 
#  * @unit: 0,01 m/s
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# VelocityComponentValue ::= INTEGER {
#     negativeOutOfRange (-16383),
#     positiveOutOfRange  (16382),
#     unavailable        (16383)
# } (-16383..16383)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -16383
int16 MAX = 16383
int16 NEGATIVE_OUT_OF_RANGE = -16383
int16 POSITIVE_OUT_OF_RANGE = 16382
int16 UNAVAILABLE = 16383


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a velocity vector in a cartesian coordinate system.
#  
#  * It shall include the following components: 
#  * 
#  * @field xVelocity: the x component of the velocity vector with the associated confidence value.
#  * 
#  * @field yVelocity: the y component of the velocity vector with the associated confidence value.
#  *
#  * @field zVelocity: the optional z component of the velocity vector with the associated confidence value.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# VelocityCartesian::= SEQUENCE {
#     xVelocity   VelocityComponent,
#     yVelocity   VelocityComponent,
#     zVelocity   VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------

VelocityComponent x_velocity

VelocityComponent y_velocity

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Acceleration3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents an acceleration vector with associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field polarAcceleration: the representation of the acceleration vector in a polar or cylindrical coordinate system. 
#  * 
#  * @field cartesianAcceleration: the representation of the acceleration vector in a cartesian coordinate system.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# Acceleration3dWithConfidence::= CHOICE {
#     polarAcceleration                    AccelerationPolarWithZ,
#     cartesianAcceleration                AccelerationCartesian 
# }
# ------------------------------------------------------------------------------

uint8 choice

AccelerationPolarWithZ polar_acceleration
uint8 CHOICE_POLAR_ACCELERATION = 0

AccelerationCartesian cartesian_acceleration
uint8 CHOICE_CARTESIAN_ACCELERATION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents an acceleration vector in a polar or cylindrical coordinate system.
#  
#  * It shall include the following components: 
#  * 
#  * @field accelerationMagnitude: magnitude of the acceleration vector projected onto the reference plane, with the associated confidence value.
#  * 
#  * @field accelerationDirection: polar angle of the acceleration vector projected onto the reference plane, with the associated confidence value.
#  *
#  * @field zAcceleration: the optional z component of the acceleration vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# AccelerationPolarWithZ::= SEQUENCE{
#     accelerationMagnitude                             AccelerationMagnitude,
#     accelerationDirection                             CartesianAngle,
#     zAcceleration                                     AccelerationComponent OPTIONAL
# }
# ------------------------------------------------------------------------------

AccelerationMagnitude acceleration_magnitude

CartesianAngle acceleration_direction

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the magnitude of the acceleration vector and associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
#  * 
#  * @field accelerationConfidence: the confidence value of the magnitude value.
#  *
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# AccelerationMagnitude::= SEQUENCE {
#     accelerationMagnitudeValue   AccelerationMagnitudeValue,
#     accelerationConfidence       AccelerationConfidence
# }
# ------------------------------------------------------------------------------

AccelerationMagnitudeValue acceleration_magnitude_value

AccelerationConfidence acceleration_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
#  *
#  * The value shall be set to:
#  * - `0` to indicate no acceleration,
#  * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  *
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# AccelerationMagnitudeValue ::= INTEGER {
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (0.. 161)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 161
uint8 POSITIVE_OUT_OF_RANGE = 160
uint8 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
#  * - `102` if the confidence value is unavailable.
#  *
#  * The value 0 shall not be used.
#  *
#  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the acceleration value may be valid and used by the application.
#  * 
#  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
#  *
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1
#  */
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an acceleration component along with a confidence value.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the confidence value associated to the provided value.
#  *
#  * @category: Kinematic Information
#  * @revision: Created in V2.1.1
#  */
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the value of an acceleration component in a defined coordinate system.
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  *
#  * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a acceleration vector in a cartesian coordinate system.
#  
#  * It shall include the following components: 
#  * 
#  * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
#  * 
#  * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
#  *
#  * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# AccelerationCartesian::= SEQUENCE{
#     xAcceleration      AccelerationComponent,
#     yAcceleration      AccelerationComponent,
#     zAcceleration      AccelerationComponent OPTIONAL
# }            
# ------------------------------------------------------------------------------

AccelerationComponent x_acceleration

AccelerationComponent y_acceleration

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
#  *
#  * It shall include the following components: 
#  *
#  * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
#  * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
#  * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
#  *
#  * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
#  * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
#  * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
#  *
#  * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
#  * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
#  * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# EulerAnglesWithConfidence ::= SEQUENCE {
#     zAngle CartesianAngle,
#     yAngle CartesianAngle OPTIONAL,
#     xAngle CartesianAngle OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianAngle z_angle

CartesianAngle y_angle
bool y_angle_is_present

CartesianAngle x_angle
bool x_angle_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an angular velocity component along with a confidence value in a cartesian coordinate system.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: The angular velocity component.
#  *
#  * @field confidence: The confidence value associated to the provided value.
#  *
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# CartesianAngularVelocityComponent ::= SEQUENCE {
#     value         CartesianAngularVelocityComponentValue,
#     confidence    AngularSpeedConfidence
# }
# ------------------------------------------------------------------------------

CartesianAngularVelocityComponentValue value

AngularSpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an angular velocity component described in a local Cartesian coordinate system, per default counted positive in
#  * a right-hand local coordinate system from the abscissa.
#  *
#  * The value shall be set to: 
#  * - `-255` if the velocity is equal to or less than -255 degrees/s,
#  * - `n` (`n > -255` and `n < 255`) if the velocity is equal to or less than n x 1 degree/s, and greater than (n-1) x 1 degree/s,
#  * - `255` if the velocity is greater than 254 degrees/s,
#  * - `256` if the information is unavailable.
#  *
#  * @unit: degree/s
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# CartesianAngularVelocityComponentValue ::= INTEGER {
#     negativeOutofRange (-255),
#     positiveOutOfRange (255),
#     unavailable	       (256)
# } (-255..256)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -255
int16 MAX = 256
int16 NEGATIVE_OUTOF_RANGE = -255
int16 POSITIVE_OUT_OF_RANGE = 255
int16 UNAVAILABLE = 256


================================================================================
MSG: etsi_its_cpm_ts_msgs/AngularSpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * For correlation computation, maximum interval levels can be assumed.
#  *
#  * The value shall be set to:
#  * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
#  * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
#  * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
#  * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
#  * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
#  * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
#  * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
#  * - 7 - `unavailable` - if the accuracy information is unavailable.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# AngularSpeedConfidence ::= ENUMERATED {
#     degSec-01   (0), 
#     degSec-02   (1),  
#     degSec-05   (2), 
#     degSec-10   (3), 
#     degSec-20   (4),  
#     degSec-50   (5), 
#     outOfRange  (6),   
#     unavailable (7)   
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEG_SEC_01 = 0
uint8 DEG_SEC_02 = 1
uint8 DEG_SEC_05 = 2
uint8 DEG_SEC_10 = 3
uint8 DEG_SEC_20 = 4
uint8 DEG_SEC_50 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF shall contain a list of a lower triangular positive semi-definite matrices.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# LowerTriangularPositiveSemidefiniteMatrices::= SEQUENCE SIZE (1..4) OF LowerTriangularPositiveSemidefiniteMatrix
# ------------------------------------------------------------------------------

LowerTriangularPositiveSemidefiniteMatrix[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a lower triangular positive semi-definite matrix. 
#  *
#  * It shall include the following components: 
#  *
#  * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix. 
#  * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
#  *
#  * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows. 
#  *
#  * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
#  * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
#  * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
#     componentsIncludedIntheMatrix   MatrixIncludedComponents,
#     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
# }
# ------------------------------------------------------------------------------

MatrixIncludedComponents components_included_inthe_matrix

LowerTriangularPositiveSemidefiniteMatrixColumns matrix


================================================================================
MSG: etsi_its_cpm_ts_msgs/MatrixIncludedComponents
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
#  *
#  * The corresponding bit shall be set to 1 if the component is included:
#  * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
#  * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,   
#  * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included, 
#  * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,   
#  * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,   
#  * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
#  * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,  
#  * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,   
#  * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
#  * - 9 - `zAngle`                        - when the component zAngle is included,
#  * - 10 - `yAngle`                       - when the component yAngle is included,   
#  * - 11 - `xAngle`                       - when the component xAngle is included,   
#  * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.   
#  *
#  * Otherwise, it shall be set to 0.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
#  */
# MatrixIncludedComponents::= BIT STRING{
#     xPosition                    (0),
#     yPosition                    (1),
#     zPosition                    (2),
#     xVelocityOrVelocityMagnitude (3),
#     yVelocityOrVelocityDirection (4),
#     zSpeed                       (5),
#     xAccelOrAccelMagnitude       (6),
#     yAccelOrAccelDirection       (7),
#     zAcceleration                (8),
#     zAngle                       (9),  
#     yAngle                      (10), 
#     xAngle                      (11), 
#     zAngularVelocity              (12)
# } (SIZE(13,...))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 13
uint8 BIT_INDEX_X_POSITION = 0
uint8 BIT_INDEX_Y_POSITION = 1
uint8 BIT_INDEX_Z_POSITION = 2
uint8 BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
uint8 BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
uint8 BIT_INDEX_Z_SPEED = 5
uint8 BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
uint8 BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
uint8 BIT_INDEX_Z_ACCELERATION = 8
uint8 BIT_INDEX_Z_ANGLE = 9
uint8 BIT_INDEX_Y_ANGLE = 10
uint8 BIT_INDEX_X_ANGLE = 11
uint8 BIT_INDEX_Z_ANGULAR_VELOCITY = 12


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrixColumns
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the columns of a lower triangular positive semi-definite matrix, each column not including the main diagonal cell of the matrix.
#  * Given a matrix "A" of size n x n, the number of @ref CorrelationColumn to be included in the lower triangular matrix is k=n-1.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# LowerTriangularPositiveSemidefiniteMatrixColumns ::= SEQUENCE SIZE (1..13) OF CorrelationColumn
# ------------------------------------------------------------------------------

CorrelationColumn[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13


================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationColumn
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
#  * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
#  * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
#  * starting at 1 from the left.
#  *
#  * @category: Sensing Information
#  * @revision: Created in V2.1.1
# */
# CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
# ------------------------------------------------------------------------------

CorrelationCellValue[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13


================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
#  *
#  * The value shall be set to: 
#  * - `-100` in case of full negative correlation,
#  * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
#  * - `0` in case of no correlation,
#  * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
#  * - `100` in case of full positive correlation,
#  * - `101` in case the correlation information is unavailable. 
#  *
#  * @unit: the value is scaled by 100
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CorrelationCellValue ::= INTEGER {
#     full-negative-correlation    (-100),     
#     no-correlation               (0),       
#     full-positive-correlation    (100),
#     unavailable (101)  
# } (-100..101)
# ------------------------------------------------------------------------------

int8 value
int8 MIN = -100
int8 MAX = 101
int8 FULL_NEGATIVE_CORRELATION = -100
int8 NO_CORRELATION = 0
int8 FULL_POSITIVE_CORRELATION = 100
int8 UNAVAILABLE = 101


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimension
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a dimension of an object together with a confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field value: the object dimension value which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the associated confidence value.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# ObjectDimension ::= SEQUENCE {
#     value         ObjectDimensionValue,
#     confidence    ObjectDimensionConfidence
# }
# ------------------------------------------------------------------------------

ObjectDimensionValue value

ObjectDimensionConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a single dimension of an object.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
#  * - `256` if the data is unavailable.
#  *
#  * @unit 0,1 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1 
# */
# ObjectDimensionValue ::= INTEGER { 
#     outOfRange              (255),
#     unavailable             (256)
# }(1..256)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 256
uint16 OUT_OF_RANGE = 255
uint16 UNAVAILABLE = 256


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
#  * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
#  * - `32` if the confidence value is unavailable.
#  *
#  * @unit 0,1 m
#  * @category: Sensing information
#  * @revision: Created in V2.1.1 
# */
# ObjectDimensionConfidence ::= INTEGER { 
#     outOfRange              (31),
#     unavailable             (32)
# } (1..32)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 32
uint8 OUT_OF_RANGE = 31
uint8 UNAVAILABLE = 32


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectPerceptionQuality
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a single-value indication about the overall information quality of a perceived object.
#  * 
#  * The value shall be set to:  
#  * - `0`                        : if there is no confidence in detected object, e.g. for "ghost"-objects or if confidence could not be computed,
#  * - `n` (`n > 0` and `n < 15`) : for the applicable confidence value,
#  * - `15`                       : if there is full confidence in the detected Object.
#  * 
#  * @unit n/a
#  * @category: Sensing information
#  * @revision: Created in V2.1.1 
# */
# ObjectPerceptionQuality ::= INTEGER {
#     noConfidence        (0), 
#     fullConfidence      (15) 
# } (0..15)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 15
uint8 NO_CONFIDENCE = 0
uint8 FULL_CONFIDENCE = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassDescription
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF shall contain a list of object classes.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# ObjectClassDescription ::= SEQUENCE (SIZE(1..8)) OF ObjectClassWithConfidence
# ------------------------------------------------------------------------------

ObjectClassWithConfidence[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the classification of a detected object together with a confidence level.
#  *
#  * It shall include the following components: 
#  *
#  * @field objectClass: the class of the object.
#  *
#  * @field Confidence: the associated confidence level.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
# */
# ObjectClassWithConfidence ::= SEQUENCE {
#     objectClass    ObjectClass,
#     confidence     ConfidenceLevel
# }
# ------------------------------------------------------------------------------

ObjectClass object_class

ConfidenceLevel confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF indicates both the class and associated subclass that best describes an object.
#  *
#  * The following options are available:
#  *
#  * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
#  *
#  * @field vruSubClass: the object is a VRU and the specific subclass is specified.
#  *
#  * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
#  *
#  * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
#  */
# ObjectClass ::= CHOICE {
#     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
#     vruSubClass          VruProfileAndSubprofile,
#     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
#     otherSubClass        OtherSubClass,
#     ...
# }
# ------------------------------------------------------------------------------

uint8 choice

TrafficParticipantType vehicle_sub_class
uint8 CHOICE_VEHICLE_SUB_CLASS = 0

VruProfileAndSubprofile vru_sub_class
uint8 CHOICE_VRU_SUB_CLASS = 1

VruClusterInformation group_sub_class
uint8 CHOICE_GROUP_SUB_CLASS = 2

OtherSubClass other_sub_class
uint8 CHOICE_OTHER_SUB_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a traffic participant.
#  * 
#  * The value shall be set to:
#  * - 0 `unknown`          - information about traffic participant is not provided,
#  * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
#  * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
#  * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
#  * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
#  * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
#  * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
#  * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
#  * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
#  * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
#  * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
#  * - 11 `tram`            - vehicle which runs on tracks along public streets,
#  * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
#  * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
#  * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
#  * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                             on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
#  * - 16-255               - are reserved for future usage.
#  * 
#  * @category: Communication information.
#  * @revision: Created in V2.1.1 based on StationType
#  */
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruProfileAndSubprofile
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the profile of a VRU including sub-profile information
#  * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
#  *
#  * @field pedestrian: VRU Profile 1 - Pedestrian.
#  *
#  * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
#  *
#  * @field motorcyclist: VRU Profile 3  - Motorcyclist.
#  *
#  * @field animal: VRU Profile  4 -  Animal.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a pedestrian.
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`             - to indicate that the information on is unavailable,
#  * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
#  * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
#  * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
#  * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
#  *
#  * The value shall be set to:
#  * - 0 `unavailable`           - to indicate that the information  is unavailable,
#  * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
#  * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
#  * - 3 `horse-and-rider`       - to indicate a horse and rider,
#  * - 4 `rollerskater`          - to indicate a rolleskater and skater,
#  * - 5 `e-scooter`             - to indicate an e-scooter and rider,
#  * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
#  * - 7 `pedelec`               - to indicate a pedelec and rider,
#  * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
#  * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a motorcyclist and corresponding vehicle.
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable `                  - to indicate that the information  is unavailable,
#  * - 1 `moped`                         - to indicate a moped and rider,
#  * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
#  * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
#  * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
#  * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of an animal
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`     - to indicate that the information  is unavailable,
#  * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
#  * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
#  * - 3 `service-animal`  - to indicate an animal that supports a human being.
#  * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF provides information about a VRU cluster.
#  *
#  * It shall include the following components: 
#  *
#  * @field clusterId: optional identifier of a VRU cluster .
#  *
#  * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
#  *
#  * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
#  *
#  * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
#  * if this component is absent it means that the information is unavailable. 
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
# */
# VruClusterInformation ::= SEQUENCE { 
#    clusterId                  Identifier1B OPTIONAL,
#    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
#    clusterCardinalitySize     CardinalNumber1B,
#    clusterProfiles            VruClusterProfiles OPTIONAL,
#    ...
# }
# ------------------------------------------------------------------------------

Identifier1B cluster_id
bool cluster_id_is_present

Shape cluster_bounding_box_shape
bool cluster_bounding_box_shape_is_present

CardinalNumber1B cluster_cardinality_size

VruClusterProfiles cluster_profiles
bool cluster_profiles_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterProfiles
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE Identifies all the VRU profile types within a cluster.
#  * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
#  * 
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
#  * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
#  * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
#  * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
#  * 
#  * Otherwise, the corresponding bit shall be set to 0.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
# */
# VruClusterProfiles ::= BIT STRING {
#     pedestrian   (0),
#     bicyclist    (1),
#     motorcyclist (2),
#     animal       (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_PEDESTRIAN = 0
uint8 BIT_INDEX_BICYCLIST = 1
uint8 BIT_INDEX_MOTORCYCLIST = 2
uint8 BIT_INDEX_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/OtherSubClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the subclass of a detected object for @ref ObjectClass "otherSubclass".
#  *
#  * The value shall be set to:
#  * - `0` - unknown          - if the subclass is unknown.
#  * - `1` - singleObject     - if the object is a single object.
#  * - `2` - multipleObjects  - if the object is a group of multiple objects.
#  * - `3` - bulkMaterial     - if the object is a bulk material.
#  *
#  * @category: Sensing information
#  * @revision: Created in V2.1.1
#  */
# OtherSubClass ::= INTEGER {
#     unknown         (0),
#     singleObject    (1),
#     multipleObjects (2),
#     bulkMaterial    (3)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 SINGLE_OBJECT = 1
uint8 MULTIPLE_OBJECTS = 2
uint8 BULK_MATERIAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  * 
#  * @field mapReference: optionally identifies the MAPEM containing the topology information.
#  * It is absent if the MAPEM topology is known from the context.
#  * 
#  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
#  *
#  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
#  * conflict area of an intersection which connects e.g an ingress with an egress lane.
#  *
#  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
#  * 
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the estimated position along the longitudinal length of a particular lane. 
#  *
#  * It shall include the following components: 
#  *
#  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
#  *
#  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
#  *
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
#  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
#  * - `32 767` if the longitudinal offset information is not available. 
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
#   -t
#   cpm_ts
#   -o
#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
#  * - `1 023` if the confidence value is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

"""
  __slots__ = ['management_container','cpm_containers']
  _slot_types = ['etsi_its_cpm_ts_msgs/ManagementContainer','etsi_its_cpm_ts_msgs/ConstraintWrappedCpmContainers']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       management_container,cpm_containers

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CpmPayload, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.management_container is None:
        self.management_container = etsi_its_cpm_ts_msgs.msg.ManagementContainer()
      if self.cpm_containers is None:
        self.cpm_containers = etsi_its_cpm_ts_msgs.msg.ConstraintWrappedCpmContainers()
    else:
      self.management_container = etsi_its_cpm_ts_msgs.msg.ManagementContainer()
      self.cpm_containers = etsi_its_cpm_ts_msgs.msg.ConstraintWrappedCpmContainers()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2i3Hi5BbBbB().pack(_x.management_container.reference_time.value, _x.management_container.reference_position.latitude.value, _x.management_container.reference_position.longitude.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_minor_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_orientation.value, _x.management_container.reference_position.altitude.altitude_value.value, _x.management_container.reference_position.altitude.altitude_confidence.value, _x.management_container.segmentation_info.total_msg_no.value, _x.management_container.segmentation_info.this_msg_no.value, _x.management_container.segmentation_info_is_present, _x.management_container.message_rate_range.message_rate_min.mantissa, _x.management_container.message_rate_range.message_rate_min.exponent, _x.management_container.message_rate_range.message_rate_max.mantissa, _x.management_container.message_rate_range.message_rate_max.exponent, _x.management_container.message_rate_range_is_present))
      length = len(self.cpm_containers.value.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.cpm_containers.value.array:
        _v1 = val1.container_id
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.container_data_originating_vehicle_container
        _v3 = _v2.orientation_angle
        _v4 = _v3.value
        _x = _v4.value
        buff.write(_get_struct_H().pack(_x))
        _v5 = _v3.confidence
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _v6 = _v2.pitch_angle
        _v7 = _v6.value
        _x = _v7.value
        buff.write(_get_struct_H().pack(_x))
        _v8 = _v6.confidence
        _x = _v8.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v2.pitch_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v9 = _v2.roll_angle
        _v10 = _v9.value
        _x = _v10.value
        buff.write(_get_struct_H().pack(_x))
        _v11 = _v9.confidence
        _x = _v11.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v2.roll_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v12 = _v2.trailer_data_set
        length = len(_v12.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v12.array:
          _v13 = val4.ref_point_id
          _x = _v13.value
          buff.write(_get_struct_B().pack(_x))
          _v14 = val4.hitch_point_offset
          _x = _v14.value
          buff.write(_get_struct_B().pack(_x))
          _v15 = val4.front_overhang
          _x = _v15.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.front_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v16 = val4.rear_overhang
          _x = _v16.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.rear_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v17 = val4.trailer_width
          _x = _v17.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.trailer_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v18 = val4.hitch_angle
          _v19 = _v18.value
          _x = _v19.value
          buff.write(_get_struct_H().pack(_x))
          _v20 = _v18.confidence
          _x = _v20.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v2.trailer_data_set_is_present
        buff.write(_get_struct_B().pack(_x))
        _v21 = val1.container_data_originating_rsu_container
        _v22 = _v21.map_reference
        _x = _v22.choice
        buff.write(_get_struct_B().pack(_x))
        _v23 = _v22.roadsegment
        _v24 = _v23.region
        _x = _v24.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v23.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v23.id
        _x = _v25.value
        buff.write(_get_struct_H().pack(_x))
        _v26 = _v22.intersection
        _v27 = _v26.region
        _x = _v27.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v26.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v28 = _v26.id
        _x = _v28.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v21.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v29 = val1.container_data_sensor_information_container
        length = len(_v29.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v29.array:
          _v30 = val3.sensor_id
          _x = _v30.value
          buff.write(_get_struct_B().pack(_x))
          _v31 = val3.sensor_type
          _x = _v31.value
          buff.write(_get_struct_B().pack(_x))
          _v32 = val3.perception_region_shape
          _x = _v32.choice
          buff.write(_get_struct_B().pack(_x))
          _v33 = _v32.rectangular
          _v34 = _v33.center_point
          _v35 = _v34.x_coordinate
          _x = _v35.value
          buff.write(_get_struct_h().pack(_x))
          _v36 = _v34.y_coordinate
          _x = _v36.value
          buff.write(_get_struct_h().pack(_x))
          _v37 = _v34.z_coordinate
          _x = _v37.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v34.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v33.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v38 = _v33.semi_length
          _x = _v38.value
          buff.write(_get_struct_H().pack(_x))
          _v39 = _v33.semi_breadth
          _x = _v39.value
          buff.write(_get_struct_H().pack(_x))
          _v40 = _v33.orientation
          _x = _v40.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v33.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v41 = _v33.height
          _x = _v41.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v33.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v42 = _v32.circular
          _v43 = _v42.shape_reference_point
          _v44 = _v43.x_coordinate
          _x = _v44.value
          buff.write(_get_struct_h().pack(_x))
          _v45 = _v43.y_coordinate
          _x = _v45.value
          buff.write(_get_struct_h().pack(_x))
          _v46 = _v43.z_coordinate
          _x = _v46.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v43.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v42.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v47 = _v42.radius
          _x = _v47.value
          buff.write(_get_struct_H().pack(_x))
          _v48 = _v42.height
          _x = _v48.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v42.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v49 = _v32.polygonal
          _v50 = _v49.shape_reference_point
          _v51 = _v50.x_coordinate
          _x = _v51.value
          buff.write(_get_struct_h().pack(_x))
          _v52 = _v50.y_coordinate
          _x = _v52.value
          buff.write(_get_struct_h().pack(_x))
          _v53 = _v50.z_coordinate
          _x = _v53.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v50.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v49.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v54 = _v49.polygon
          length = len(_v54.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v54.array:
            _v55 = val7.x_coordinate
            _x = _v55.value
            buff.write(_get_struct_h().pack(_x))
            _v56 = val7.y_coordinate
            _x = _v56.value
            buff.write(_get_struct_h().pack(_x))
            _v57 = val7.z_coordinate
            _x = _v57.value
            buff.write(_get_struct_h().pack(_x))
            _x = val7.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v58 = _v49.height
          _x = _v58.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v49.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v59 = _v32.elliptical
          _v60 = _v59.shape_reference_point
          _v61 = _v60.x_coordinate
          _x = _v61.value
          buff.write(_get_struct_h().pack(_x))
          _v62 = _v60.y_coordinate
          _x = _v62.value
          buff.write(_get_struct_h().pack(_x))
          _v63 = _v60.z_coordinate
          _x = _v63.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v60.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v59.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v64 = _v59.semi_major_axis_length
          _x = _v64.value
          buff.write(_get_struct_H().pack(_x))
          _v65 = _v59.semi_minor_axis_length
          _x = _v65.value
          buff.write(_get_struct_H().pack(_x))
          _v66 = _v59.orientation
          _x = _v66.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v59.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v67 = _v59.height
          _x = _v67.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v59.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v68 = _v32.radial
          _v69 = _v68.shape_reference_point
          _v70 = _v69.x_coordinate
          _x = _v70.value
          buff.write(_get_struct_h().pack(_x))
          _v71 = _v69.y_coordinate
          _x = _v71.value
          buff.write(_get_struct_h().pack(_x))
          _v72 = _v69.z_coordinate
          _x = _v72.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v69.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v68.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v73 = _v68.range
          _x = _v73.value
          buff.write(_get_struct_H().pack(_x))
          _v74 = _v68.stationary_horizontal_opening_angle_start
          _x = _v74.value
          buff.write(_get_struct_H().pack(_x))
          _v75 = _v68.stationary_horizontal_opening_angle_end
          _x = _v75.value
          buff.write(_get_struct_H().pack(_x))
          _v76 = _v68.vertical_opening_angle_start
          _x = _v76.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v68.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v77 = _v68.vertical_opening_angle_end
          _x = _v77.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v68.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v78 = _v32.radial_shapes
          _v79 = _v78.ref_point_id
          _x = _v79.value
          buff.write(_get_struct_B().pack(_x))
          _v80 = _v78.x_coordinate
          _x = _v80.value
          buff.write(_get_struct_h().pack(_x))
          _v81 = _v78.y_coordinate
          _x = _v81.value
          buff.write(_get_struct_h().pack(_x))
          _v82 = _v78.z_coordinate
          _x = _v82.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v78.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v83 = _v78.radial_shapes_list
          length = len(_v83.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v83.array:
            _v84 = val7.range
            _x = _v84.value
            buff.write(_get_struct_H().pack(_x))
            _v85 = val7.horizontal_opening_angle_start
            _x = _v85.value
            buff.write(_get_struct_H().pack(_x))
            _v86 = val7.horizontal_opening_angle_end
            _x = _v86.value
            buff.write(_get_struct_H().pack(_x))
            _v87 = val7.vertical_opening_angle_start
            _x = _v87.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v88 = val7.vertical_opening_angle_end
            _x = _v88.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val3.perception_region_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v89 = val3.perception_region_confidence
          _x = _v89.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3
          buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
        _v90 = val1.container_data_perception_region_container
        length = len(_v90.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v90.array:
          _v91 = val3.measurement_delta_time
          _x = _v91.value
          buff.write(_get_struct_h().pack(_x))
          _v92 = val3.perception_region_confidence
          _x = _v92.value
          buff.write(_get_struct_B().pack(_x))
          _v93 = val3.perception_region_shape
          _x = _v93.choice
          buff.write(_get_struct_B().pack(_x))
          _v94 = _v93.rectangular
          _v95 = _v94.center_point
          _v96 = _v95.x_coordinate
          _x = _v96.value
          buff.write(_get_struct_h().pack(_x))
          _v97 = _v95.y_coordinate
          _x = _v97.value
          buff.write(_get_struct_h().pack(_x))
          _v98 = _v95.z_coordinate
          _x = _v98.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v95.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v94.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v99 = _v94.semi_length
          _x = _v99.value
          buff.write(_get_struct_H().pack(_x))
          _v100 = _v94.semi_breadth
          _x = _v100.value
          buff.write(_get_struct_H().pack(_x))
          _v101 = _v94.orientation
          _x = _v101.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v94.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v102 = _v94.height
          _x = _v102.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v94.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v103 = _v93.circular
          _v104 = _v103.shape_reference_point
          _v105 = _v104.x_coordinate
          _x = _v105.value
          buff.write(_get_struct_h().pack(_x))
          _v106 = _v104.y_coordinate
          _x = _v106.value
          buff.write(_get_struct_h().pack(_x))
          _v107 = _v104.z_coordinate
          _x = _v107.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v104.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v103.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v108 = _v103.radius
          _x = _v108.value
          buff.write(_get_struct_H().pack(_x))
          _v109 = _v103.height
          _x = _v109.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v103.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v110 = _v93.polygonal
          _v111 = _v110.shape_reference_point
          _v112 = _v111.x_coordinate
          _x = _v112.value
          buff.write(_get_struct_h().pack(_x))
          _v113 = _v111.y_coordinate
          _x = _v113.value
          buff.write(_get_struct_h().pack(_x))
          _v114 = _v111.z_coordinate
          _x = _v114.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v111.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v110.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v115 = _v110.polygon
          length = len(_v115.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v115.array:
            _v116 = val7.x_coordinate
            _x = _v116.value
            buff.write(_get_struct_h().pack(_x))
            _v117 = val7.y_coordinate
            _x = _v117.value
            buff.write(_get_struct_h().pack(_x))
            _v118 = val7.z_coordinate
            _x = _v118.value
            buff.write(_get_struct_h().pack(_x))
            _x = val7.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v119 = _v110.height
          _x = _v119.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v110.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v120 = _v93.elliptical
          _v121 = _v120.shape_reference_point
          _v122 = _v121.x_coordinate
          _x = _v122.value
          buff.write(_get_struct_h().pack(_x))
          _v123 = _v121.y_coordinate
          _x = _v123.value
          buff.write(_get_struct_h().pack(_x))
          _v124 = _v121.z_coordinate
          _x = _v124.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v121.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v120.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v125 = _v120.semi_major_axis_length
          _x = _v125.value
          buff.write(_get_struct_H().pack(_x))
          _v126 = _v120.semi_minor_axis_length
          _x = _v126.value
          buff.write(_get_struct_H().pack(_x))
          _v127 = _v120.orientation
          _x = _v127.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v120.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v128 = _v120.height
          _x = _v128.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v120.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v129 = _v93.radial
          _v130 = _v129.shape_reference_point
          _v131 = _v130.x_coordinate
          _x = _v131.value
          buff.write(_get_struct_h().pack(_x))
          _v132 = _v130.y_coordinate
          _x = _v132.value
          buff.write(_get_struct_h().pack(_x))
          _v133 = _v130.z_coordinate
          _x = _v133.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v130.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v129.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v134 = _v129.range
          _x = _v134.value
          buff.write(_get_struct_H().pack(_x))
          _v135 = _v129.stationary_horizontal_opening_angle_start
          _x = _v135.value
          buff.write(_get_struct_H().pack(_x))
          _v136 = _v129.stationary_horizontal_opening_angle_end
          _x = _v136.value
          buff.write(_get_struct_H().pack(_x))
          _v137 = _v129.vertical_opening_angle_start
          _x = _v137.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v129.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v138 = _v129.vertical_opening_angle_end
          _x = _v138.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v129.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v139 = _v93.radial_shapes
          _v140 = _v139.ref_point_id
          _x = _v140.value
          buff.write(_get_struct_B().pack(_x))
          _v141 = _v139.x_coordinate
          _x = _v141.value
          buff.write(_get_struct_h().pack(_x))
          _v142 = _v139.y_coordinate
          _x = _v142.value
          buff.write(_get_struct_h().pack(_x))
          _v143 = _v139.z_coordinate
          _x = _v143.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v139.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v144 = _v139.radial_shapes_list
          length = len(_v144.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v144.array:
            _v145 = val7.range
            _x = _v145.value
            buff.write(_get_struct_H().pack(_x))
            _v146 = val7.horizontal_opening_angle_start
            _x = _v146.value
            buff.write(_get_struct_H().pack(_x))
            _v147 = val7.horizontal_opening_angle_end
            _x = _v147.value
            buff.write(_get_struct_H().pack(_x))
            _v148 = val7.vertical_opening_angle_start
            _x = _v148.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v149 = val7.vertical_opening_angle_end
            _x = _v149.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val3.shadowing_applies
          buff.write(_get_struct_B().pack(_x))
          _v150 = val3.sensor_id_list
          length = len(_v150.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v150.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v151 = val3.number_of_perceived_objects
          _x = _v151.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3.number_of_perceived_objects_is_present
          buff.write(_get_struct_B().pack(_x))
          _v152 = val3.perceived_object_ids
          length = len(_v152.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v152.array:
            _x = val5.value
            buff.write(_get_struct_H().pack(_x))
          _x = val3.perceived_object_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _v153 = val1.container_data_perceived_object_container
        _v154 = _v153.number_of_perceived_objects
        _x = _v154.value
        buff.write(_get_struct_B().pack(_x))
        _v155 = _v153.perceived_objects
        length = len(_v155.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v155.array:
          _v156 = val4.object_id
          _x = _v156.value
          buff.write(_get_struct_H().pack(_x))
          _x = val4.object_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v157 = val4.measurement_delta_time
          _x = _v157.value
          buff.write(_get_struct_h().pack(_x))
          _v158 = val4.position
          _v159 = _v158.x_coordinate
          _v160 = _v159.value
          _x = _v160.value
          buff.write(_get_struct_i().pack(_x))
          _v161 = _v159.confidence
          _x = _v161.value
          buff.write(_get_struct_H().pack(_x))
          _v162 = _v158.y_coordinate
          _v163 = _v162.value
          _x = _v163.value
          buff.write(_get_struct_i().pack(_x))
          _v164 = _v162.confidence
          _x = _v164.value
          buff.write(_get_struct_H().pack(_x))
          _v165 = _v158.z_coordinate
          _v166 = _v165.value
          _x = _v166.value
          buff.write(_get_struct_i().pack(_x))
          _v167 = _v165.confidence
          _x = _v167.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v158.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v168 = val4.velocity
          _x = _v168.choice
          buff.write(_get_struct_B().pack(_x))
          _v169 = _v168.polar_velocity
          _v170 = _v169.velocity_magnitude
          _v171 = _v170.speed_value
          _x = _v171.value
          buff.write(_get_struct_H().pack(_x))
          _v172 = _v170.speed_confidence
          _x = _v172.value
          buff.write(_get_struct_B().pack(_x))
          _v173 = _v169.velocity_direction
          _v174 = _v173.value
          _x = _v174.value
          buff.write(_get_struct_H().pack(_x))
          _v175 = _v173.confidence
          _x = _v175.value
          buff.write(_get_struct_B().pack(_x))
          _v176 = _v169.z_velocity
          _v177 = _v176.value
          _x = _v177.value
          buff.write(_get_struct_h().pack(_x))
          _v178 = _v176.confidence
          _x = _v178.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v169.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v179 = _v168.cartesian_velocity
          _v180 = _v179.x_velocity
          _v181 = _v180.value
          _x = _v181.value
          buff.write(_get_struct_h().pack(_x))
          _v182 = _v180.confidence
          _x = _v182.value
          buff.write(_get_struct_B().pack(_x))
          _v183 = _v179.y_velocity
          _v184 = _v183.value
          _x = _v184.value
          buff.write(_get_struct_h().pack(_x))
          _v185 = _v183.confidence
          _x = _v185.value
          buff.write(_get_struct_B().pack(_x))
          _v186 = _v179.z_velocity
          _v187 = _v186.value
          _x = _v187.value
          buff.write(_get_struct_h().pack(_x))
          _v188 = _v186.confidence
          _x = _v188.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v179.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v189 = val4.acceleration
          _x = _v189.choice
          buff.write(_get_struct_B().pack(_x))
          _v190 = _v189.polar_acceleration
          _v191 = _v190.acceleration_magnitude
          _v192 = _v191.acceleration_magnitude_value
          _x = _v192.value
          buff.write(_get_struct_B().pack(_x))
          _v193 = _v191.acceleration_confidence
          _x = _v193.value
          buff.write(_get_struct_B().pack(_x))
          _v194 = _v190.acceleration_direction
          _v195 = _v194.value
          _x = _v195.value
          buff.write(_get_struct_H().pack(_x))
          _v196 = _v194.confidence
          _x = _v196.value
          buff.write(_get_struct_B().pack(_x))
          _v197 = _v190.z_acceleration
          _v198 = _v197.value
          _x = _v198.value
          buff.write(_get_struct_h().pack(_x))
          _v199 = _v197.confidence
          _x = _v199.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v190.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v200 = _v189.cartesian_acceleration
          _v201 = _v200.x_acceleration
          _v202 = _v201.value
          _x = _v202.value
          buff.write(_get_struct_h().pack(_x))
          _v203 = _v201.confidence
          _x = _v203.value
          buff.write(_get_struct_B().pack(_x))
          _v204 = _v200.y_acceleration
          _v205 = _v204.value
          _x = _v205.value
          buff.write(_get_struct_h().pack(_x))
          _v206 = _v204.confidence
          _x = _v206.value
          buff.write(_get_struct_B().pack(_x))
          _v207 = _v200.z_acceleration
          _v208 = _v207.value
          _x = _v208.value
          buff.write(_get_struct_h().pack(_x))
          _v209 = _v207.confidence
          _x = _v209.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v200.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v210 = val4.angles
          _v211 = _v210.z_angle
          _v212 = _v211.value
          _x = _v212.value
          buff.write(_get_struct_H().pack(_x))
          _v213 = _v211.confidence
          _x = _v213.value
          buff.write(_get_struct_B().pack(_x))
          _v214 = _v210.y_angle
          _v215 = _v214.value
          _x = _v215.value
          buff.write(_get_struct_H().pack(_x))
          _v216 = _v214.confidence
          _x = _v216.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v210.y_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _v217 = _v210.x_angle
          _v218 = _v217.value
          _x = _v218.value
          buff.write(_get_struct_H().pack(_x))
          _v219 = _v217.confidence
          _x = _v219.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v210.x_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.angles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v220 = val4.z_angular_velocity
          _v221 = _v220.value
          _x = _v221.value
          buff.write(_get_struct_h().pack(_x))
          _v222 = _v220.confidence
          _x = _v222.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.z_angular_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v223 = val4.lower_triangular_correlation_matrices
          length = len(_v223.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v223.array:
            _v224 = val6.components_included_inthe_matrix
            _x = _v224.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v224.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _v225 = val6.matrix
            length = len(_v225.array)
            buff.write(_struct_I.pack(length))
            for val8 in _v225.array:
              length = len(val8.array)
              buff.write(_struct_I.pack(length))
              for val9 in val8.array:
                _x = val9.value
                buff.write(_get_struct_b().pack(_x))
          _x = val4.lower_triangular_correlation_matrices_is_present
          buff.write(_get_struct_B().pack(_x))
          _v226 = val4.object_dimension_z
          _v227 = _v226.value
          _x = _v227.value
          buff.write(_get_struct_H().pack(_x))
          _v228 = _v226.confidence
          _x = _v228.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_z_is_present
          buff.write(_get_struct_B().pack(_x))
          _v229 = val4.object_dimension_y
          _v230 = _v229.value
          _x = _v230.value
          buff.write(_get_struct_H().pack(_x))
          _v231 = _v229.confidence
          _x = _v231.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_y_is_present
          buff.write(_get_struct_B().pack(_x))
          _v232 = val4.object_dimension_x
          _v233 = _v232.value
          _x = _v233.value
          buff.write(_get_struct_H().pack(_x))
          _v234 = _v232.confidence
          _x = _v234.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_x_is_present
          buff.write(_get_struct_B().pack(_x))
          _v235 = val4.object_age
          _x = _v235.value
          buff.write(_get_struct_h().pack(_x))
          _x = val4.object_age_is_present
          buff.write(_get_struct_B().pack(_x))
          _v236 = val4.object_perception_quality
          _x = _v236.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_perception_quality_is_present
          buff.write(_get_struct_B().pack(_x))
          _v237 = val4.sensor_id_list
          length = len(_v237.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v237.array:
            _x = val6.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v238 = val4.classification
          length = len(_v238.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v238.array:
            _v239 = val6.object_class
            _x = _v239.choice
            buff.write(_get_struct_B().pack(_x))
            _v240 = _v239.vehicle_sub_class
            _x = _v240.value
            buff.write(_get_struct_B().pack(_x))
            _v241 = _v239.vru_sub_class
            _x = _v241.choice
            buff.write(_get_struct_B().pack(_x))
            _v242 = _v241.pedestrian
            _x = _v242.value
            buff.write(_get_struct_B().pack(_x))
            _v243 = _v241.bicyclist_and_light_vru_vehicle
            _x = _v243.value
            buff.write(_get_struct_B().pack(_x))
            _v244 = _v241.motorcyclist
            _x = _v244.value
            buff.write(_get_struct_B().pack(_x))
            _v245 = _v241.animal
            _x = _v245.value
            buff.write(_get_struct_B().pack(_x))
            _v246 = _v239.group_sub_class
            _v247 = _v246.cluster_id
            _x = _v247.value
            buff.write(_get_struct_B().pack(_x))
            _x = _v246.cluster_id_is_present
            buff.write(_get_struct_B().pack(_x))
            _v248 = _v246.cluster_bounding_box_shape
            _x = _v248.choice
            buff.write(_get_struct_B().pack(_x))
            _v249 = _v248.rectangular
            _v250 = _v249.center_point
            _v251 = _v250.x_coordinate
            _x = _v251.value
            buff.write(_get_struct_h().pack(_x))
            _v252 = _v250.y_coordinate
            _x = _v252.value
            buff.write(_get_struct_h().pack(_x))
            _v253 = _v250.z_coordinate
            _x = _v253.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v250.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v249.center_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v254 = _v249.semi_length
            _x = _v254.value
            buff.write(_get_struct_H().pack(_x))
            _v255 = _v249.semi_breadth
            _x = _v255.value
            buff.write(_get_struct_H().pack(_x))
            _v256 = _v249.orientation
            _x = _v256.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v249.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v257 = _v249.height
            _x = _v257.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v249.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v258 = _v248.circular
            _v259 = _v258.shape_reference_point
            _v260 = _v259.x_coordinate
            _x = _v260.value
            buff.write(_get_struct_h().pack(_x))
            _v261 = _v259.y_coordinate
            _x = _v261.value
            buff.write(_get_struct_h().pack(_x))
            _v262 = _v259.z_coordinate
            _x = _v262.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v259.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v258.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v263 = _v258.radius
            _x = _v263.value
            buff.write(_get_struct_H().pack(_x))
            _v264 = _v258.height
            _x = _v264.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v258.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v265 = _v248.polygonal
            _v266 = _v265.shape_reference_point
            _v267 = _v266.x_coordinate
            _x = _v267.value
            buff.write(_get_struct_h().pack(_x))
            _v268 = _v266.y_coordinate
            _x = _v268.value
            buff.write(_get_struct_h().pack(_x))
            _v269 = _v266.z_coordinate
            _x = _v269.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v266.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v265.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v270 = _v265.polygon
            length = len(_v270.array)
            buff.write(_struct_I.pack(length))
            for val12 in _v270.array:
              _v271 = val12.x_coordinate
              _x = _v271.value
              buff.write(_get_struct_h().pack(_x))
              _v272 = val12.y_coordinate
              _x = _v272.value
              buff.write(_get_struct_h().pack(_x))
              _v273 = val12.z_coordinate
              _x = _v273.value
              buff.write(_get_struct_h().pack(_x))
              _x = val12.z_coordinate_is_present
              buff.write(_get_struct_B().pack(_x))
            _v274 = _v265.height
            _x = _v274.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v265.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v275 = _v248.elliptical
            _v276 = _v275.shape_reference_point
            _v277 = _v276.x_coordinate
            _x = _v277.value
            buff.write(_get_struct_h().pack(_x))
            _v278 = _v276.y_coordinate
            _x = _v278.value
            buff.write(_get_struct_h().pack(_x))
            _v279 = _v276.z_coordinate
            _x = _v279.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v276.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v275.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v280 = _v275.semi_major_axis_length
            _x = _v280.value
            buff.write(_get_struct_H().pack(_x))
            _v281 = _v275.semi_minor_axis_length
            _x = _v281.value
            buff.write(_get_struct_H().pack(_x))
            _v282 = _v275.orientation
            _x = _v282.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v275.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v283 = _v275.height
            _x = _v283.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v275.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v284 = _v248.radial
            _v285 = _v284.shape_reference_point
            _v286 = _v285.x_coordinate
            _x = _v286.value
            buff.write(_get_struct_h().pack(_x))
            _v287 = _v285.y_coordinate
            _x = _v287.value
            buff.write(_get_struct_h().pack(_x))
            _v288 = _v285.z_coordinate
            _x = _v288.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v285.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v284.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v289 = _v284.range
            _x = _v289.value
            buff.write(_get_struct_H().pack(_x))
            _v290 = _v284.stationary_horizontal_opening_angle_start
            _x = _v290.value
            buff.write(_get_struct_H().pack(_x))
            _v291 = _v284.stationary_horizontal_opening_angle_end
            _x = _v291.value
            buff.write(_get_struct_H().pack(_x))
            _v292 = _v284.vertical_opening_angle_start
            _x = _v292.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v284.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v293 = _v284.vertical_opening_angle_end
            _x = _v293.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v284.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
            _v294 = _v248.radial_shapes
            _v295 = _v294.ref_point_id
            _x = _v295.value
            buff.write(_get_struct_B().pack(_x))
            _v296 = _v294.x_coordinate
            _x = _v296.value
            buff.write(_get_struct_h().pack(_x))
            _v297 = _v294.y_coordinate
            _x = _v297.value
            buff.write(_get_struct_h().pack(_x))
            _v298 = _v294.z_coordinate
            _x = _v298.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v294.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _v299 = _v294.radial_shapes_list
            length = len(_v299.array)
            buff.write(_struct_I.pack(length))
            for val12 in _v299.array:
              _v300 = val12.range
              _x = _v300.value
              buff.write(_get_struct_H().pack(_x))
              _v301 = val12.horizontal_opening_angle_start
              _x = _v301.value
              buff.write(_get_struct_H().pack(_x))
              _v302 = val12.horizontal_opening_angle_end
              _x = _v302.value
              buff.write(_get_struct_H().pack(_x))
              _v303 = val12.vertical_opening_angle_start
              _x = _v303.value
              buff.write(_get_struct_H().pack(_x))
              _x = val12.vertical_opening_angle_start_is_present
              buff.write(_get_struct_B().pack(_x))
              _v304 = val12.vertical_opening_angle_end
              _x = _v304.value
              buff.write(_get_struct_H().pack(_x))
              _x = val12.vertical_opening_angle_end_is_present
              buff.write(_get_struct_B().pack(_x))
            _x = _v246.cluster_bounding_box_shape_is_present
            buff.write(_get_struct_B().pack(_x))
            _v305 = _v246.cluster_cardinality_size
            _x = _v305.value
            buff.write(_get_struct_B().pack(_x))
            _v306 = _v246.cluster_profiles
            _x = _v306.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v306.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _x = _v246.cluster_profiles_is_present
            buff.write(_get_struct_B().pack(_x))
            _v307 = _v239.other_sub_class
            _x = _v307.value
            buff.write(_get_struct_B().pack(_x))
            _v308 = val6.confidence
            _x = _v308.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.classification_is_present
          buff.write(_get_struct_B().pack(_x))
          _v309 = val4.map_position
          _v310 = _v309.map_reference
          _x = _v310.choice
          buff.write(_get_struct_B().pack(_x))
          _v311 = _v310.roadsegment
          _v312 = _v311.region
          _x = _v312.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v311.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v313 = _v311.id
          _x = _v313.value
          buff.write(_get_struct_H().pack(_x))
          _v314 = _v310.intersection
          _v315 = _v314.region
          _x = _v315.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v314.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v316 = _v314.id
          _x = _v316.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v309.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v317 = _v309.lane_id
          _x = _v317.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v309.lane_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v318 = _v309.connection_id
          _x = _v318.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v309.connection_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v319 = _v309.longitudinal_lane_position
          _v320 = _v319.longitudinal_lane_position_value
          _x = _v320.value
          buff.write(_get_struct_H().pack(_x))
          _v321 = _v319.longitudinal_lane_position_confidence
          _x = _v321.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v309.longitudinal_lane_position_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.map_position_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.management_container is None:
        self.management_container = etsi_its_cpm_ts_msgs.msg.ManagementContainer()
      if self.cpm_containers is None:
        self.cpm_containers = etsi_its_cpm_ts_msgs.msg.ConstraintWrappedCpmContainers()
      end = 0
      _x = self
      start = end
      end += 35
      (_x.management_container.reference_time.value, _x.management_container.reference_position.latitude.value, _x.management_container.reference_position.longitude.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_minor_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_orientation.value, _x.management_container.reference_position.altitude.altitude_value.value, _x.management_container.reference_position.altitude.altitude_confidence.value, _x.management_container.segmentation_info.total_msg_no.value, _x.management_container.segmentation_info.this_msg_no.value, _x.management_container.segmentation_info_is_present, _x.management_container.message_rate_range.message_rate_min.mantissa, _x.management_container.message_rate_range.message_rate_min.exponent, _x.management_container.message_rate_range.message_rate_max.mantissa, _x.management_container.message_rate_range.message_rate_max.exponent, _x.management_container.message_rate_range_is_present,) = _get_struct_Q2i3Hi5BbBbB().unpack(str[start:end])
      self.management_container.segmentation_info_is_present = bool(self.management_container.segmentation_info_is_present)
      self.management_container.message_rate_range_is_present = bool(self.management_container.message_rate_range_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cpm_containers.value.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.WrappedCpmContainer()
        _v322 = val1.container_id
        start = end
        end += 1
        (_v322.value,) = _get_struct_B().unpack(str[start:end])
        _v323 = val1.container_data_originating_vehicle_container
        _v324 = _v323.orientation_angle
        _v325 = _v324.value
        start = end
        end += 2
        (_v325.value,) = _get_struct_H().unpack(str[start:end])
        _v326 = _v324.confidence
        start = end
        end += 1
        (_v326.value,) = _get_struct_B().unpack(str[start:end])
        _v327 = _v323.pitch_angle
        _v328 = _v327.value
        start = end
        end += 2
        (_v328.value,) = _get_struct_H().unpack(str[start:end])
        _v329 = _v327.confidence
        start = end
        end += 1
        (_v329.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v323.pitch_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v323.pitch_angle_is_present = bool(_v323.pitch_angle_is_present)
        _v330 = _v323.roll_angle
        _v331 = _v330.value
        start = end
        end += 2
        (_v331.value,) = _get_struct_H().unpack(str[start:end])
        _v332 = _v330.confidence
        start = end
        end += 1
        (_v332.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v323.roll_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v323.roll_angle_is_present = bool(_v323.roll_angle_is_present)
        _v333 = _v323.trailer_data_set
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v333.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.TrailerData()
          _v334 = val4.ref_point_id
          start = end
          end += 1
          (_v334.value,) = _get_struct_B().unpack(str[start:end])
          _v335 = val4.hitch_point_offset
          start = end
          end += 1
          (_v335.value,) = _get_struct_B().unpack(str[start:end])
          _v336 = val4.front_overhang
          start = end
          end += 1
          (_v336.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.front_overhang_is_present = bool(val4.front_overhang_is_present)
          _v337 = val4.rear_overhang
          start = end
          end += 1
          (_v337.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.rear_overhang_is_present = bool(val4.rear_overhang_is_present)
          _v338 = val4.trailer_width
          start = end
          end += 1
          (_v338.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.trailer_width_is_present = bool(val4.trailer_width_is_present)
          _v339 = val4.hitch_angle
          _v340 = _v339.value
          start = end
          end += 2
          (_v340.value,) = _get_struct_H().unpack(str[start:end])
          _v341 = _v339.confidence
          start = end
          end += 1
          (_v341.value,) = _get_struct_B().unpack(str[start:end])
          _v333.array.append(val4)
        start = end
        end += 1
        (_v323.trailer_data_set_is_present,) = _get_struct_B().unpack(str[start:end])
        _v323.trailer_data_set_is_present = bool(_v323.trailer_data_set_is_present)
        _v342 = val1.container_data_originating_rsu_container
        _v343 = _v342.map_reference
        start = end
        end += 1
        (_v343.choice,) = _get_struct_B().unpack(str[start:end])
        _v344 = _v343.roadsegment
        _v345 = _v344.region
        start = end
        end += 2
        (_v345.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v344.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v344.region_is_present = bool(_v344.region_is_present)
        _v346 = _v344.id
        start = end
        end += 2
        (_v346.value,) = _get_struct_H().unpack(str[start:end])
        _v347 = _v343.intersection
        _v348 = _v347.region
        start = end
        end += 2
        (_v348.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v347.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v347.region_is_present = bool(_v347.region_is_present)
        _v349 = _v347.id
        start = end
        end += 2
        (_v349.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v342.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v342.map_reference_is_present = bool(_v342.map_reference_is_present)
        _v350 = val1.container_data_sensor_information_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v350.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
          _v351 = val3.sensor_id
          start = end
          end += 1
          (_v351.value,) = _get_struct_B().unpack(str[start:end])
          _v352 = val3.sensor_type
          start = end
          end += 1
          (_v352.value,) = _get_struct_B().unpack(str[start:end])
          _v353 = val3.perception_region_shape
          start = end
          end += 1
          (_v353.choice,) = _get_struct_B().unpack(str[start:end])
          _v354 = _v353.rectangular
          _v355 = _v354.center_point
          _v356 = _v355.x_coordinate
          start = end
          end += 2
          (_v356.value,) = _get_struct_h().unpack(str[start:end])
          _v357 = _v355.y_coordinate
          start = end
          end += 2
          (_v357.value,) = _get_struct_h().unpack(str[start:end])
          _v358 = _v355.z_coordinate
          start = end
          end += 2
          (_v358.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v355.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v355.z_coordinate_is_present = bool(_v355.z_coordinate_is_present)
          start = end
          end += 1
          (_v354.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v354.center_point_is_present = bool(_v354.center_point_is_present)
          _v359 = _v354.semi_length
          start = end
          end += 2
          (_v359.value,) = _get_struct_H().unpack(str[start:end])
          _v360 = _v354.semi_breadth
          start = end
          end += 2
          (_v360.value,) = _get_struct_H().unpack(str[start:end])
          _v361 = _v354.orientation
          start = end
          end += 2
          (_v361.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v354.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v354.orientation_is_present = bool(_v354.orientation_is_present)
          _v362 = _v354.height
          start = end
          end += 2
          (_v362.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v354.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v354.height_is_present = bool(_v354.height_is_present)
          _v363 = _v353.circular
          _v364 = _v363.shape_reference_point
          _v365 = _v364.x_coordinate
          start = end
          end += 2
          (_v365.value,) = _get_struct_h().unpack(str[start:end])
          _v366 = _v364.y_coordinate
          start = end
          end += 2
          (_v366.value,) = _get_struct_h().unpack(str[start:end])
          _v367 = _v364.z_coordinate
          start = end
          end += 2
          (_v367.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v364.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v364.z_coordinate_is_present = bool(_v364.z_coordinate_is_present)
          start = end
          end += 1
          (_v363.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v363.shape_reference_point_is_present = bool(_v363.shape_reference_point_is_present)
          _v368 = _v363.radius
          start = end
          end += 2
          (_v368.value,) = _get_struct_H().unpack(str[start:end])
          _v369 = _v363.height
          start = end
          end += 2
          (_v369.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v363.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v363.height_is_present = bool(_v363.height_is_present)
          _v370 = _v353.polygonal
          _v371 = _v370.shape_reference_point
          _v372 = _v371.x_coordinate
          start = end
          end += 2
          (_v372.value,) = _get_struct_h().unpack(str[start:end])
          _v373 = _v371.y_coordinate
          start = end
          end += 2
          (_v373.value,) = _get_struct_h().unpack(str[start:end])
          _v374 = _v371.z_coordinate
          start = end
          end += 2
          (_v374.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v371.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v371.z_coordinate_is_present = bool(_v371.z_coordinate_is_present)
          start = end
          end += 1
          (_v370.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v370.shape_reference_point_is_present = bool(_v370.shape_reference_point_is_present)
          _v375 = _v370.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v375.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v376 = val7.x_coordinate
            start = end
            end += 2
            (_v376.value,) = _get_struct_h().unpack(str[start:end])
            _v377 = val7.y_coordinate
            start = end
            end += 2
            (_v377.value,) = _get_struct_h().unpack(str[start:end])
            _v378 = val7.z_coordinate
            start = end
            end += 2
            (_v378.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
            _v375.array.append(val7)
          _v379 = _v370.height
          start = end
          end += 2
          (_v379.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v370.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v370.height_is_present = bool(_v370.height_is_present)
          _v380 = _v353.elliptical
          _v381 = _v380.shape_reference_point
          _v382 = _v381.x_coordinate
          start = end
          end += 2
          (_v382.value,) = _get_struct_h().unpack(str[start:end])
          _v383 = _v381.y_coordinate
          start = end
          end += 2
          (_v383.value,) = _get_struct_h().unpack(str[start:end])
          _v384 = _v381.z_coordinate
          start = end
          end += 2
          (_v384.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v381.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v381.z_coordinate_is_present = bool(_v381.z_coordinate_is_present)
          start = end
          end += 1
          (_v380.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v380.shape_reference_point_is_present = bool(_v380.shape_reference_point_is_present)
          _v385 = _v380.semi_major_axis_length
          start = end
          end += 2
          (_v385.value,) = _get_struct_H().unpack(str[start:end])
          _v386 = _v380.semi_minor_axis_length
          start = end
          end += 2
          (_v386.value,) = _get_struct_H().unpack(str[start:end])
          _v387 = _v380.orientation
          start = end
          end += 2
          (_v387.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v380.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v380.orientation_is_present = bool(_v380.orientation_is_present)
          _v388 = _v380.height
          start = end
          end += 2
          (_v388.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v380.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v380.height_is_present = bool(_v380.height_is_present)
          _v389 = _v353.radial
          _v390 = _v389.shape_reference_point
          _v391 = _v390.x_coordinate
          start = end
          end += 2
          (_v391.value,) = _get_struct_h().unpack(str[start:end])
          _v392 = _v390.y_coordinate
          start = end
          end += 2
          (_v392.value,) = _get_struct_h().unpack(str[start:end])
          _v393 = _v390.z_coordinate
          start = end
          end += 2
          (_v393.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v390.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v390.z_coordinate_is_present = bool(_v390.z_coordinate_is_present)
          start = end
          end += 1
          (_v389.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v389.shape_reference_point_is_present = bool(_v389.shape_reference_point_is_present)
          _v394 = _v389.range
          start = end
          end += 2
          (_v394.value,) = _get_struct_H().unpack(str[start:end])
          _v395 = _v389.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v395.value,) = _get_struct_H().unpack(str[start:end])
          _v396 = _v389.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v396.value,) = _get_struct_H().unpack(str[start:end])
          _v397 = _v389.vertical_opening_angle_start
          start = end
          end += 2
          (_v397.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v389.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v389.vertical_opening_angle_start_is_present = bool(_v389.vertical_opening_angle_start_is_present)
          _v398 = _v389.vertical_opening_angle_end
          start = end
          end += 2
          (_v398.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v389.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v389.vertical_opening_angle_end_is_present = bool(_v389.vertical_opening_angle_end_is_present)
          _v399 = _v353.radial_shapes
          _v400 = _v399.ref_point_id
          start = end
          end += 1
          (_v400.value,) = _get_struct_B().unpack(str[start:end])
          _v401 = _v399.x_coordinate
          start = end
          end += 2
          (_v401.value,) = _get_struct_h().unpack(str[start:end])
          _v402 = _v399.y_coordinate
          start = end
          end += 2
          (_v402.value,) = _get_struct_h().unpack(str[start:end])
          _v403 = _v399.z_coordinate
          start = end
          end += 2
          (_v403.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v399.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v399.z_coordinate_is_present = bool(_v399.z_coordinate_is_present)
          _v404 = _v399.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v404.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v405 = val7.range
            start = end
            end += 2
            (_v405.value,) = _get_struct_H().unpack(str[start:end])
            _v406 = val7.horizontal_opening_angle_start
            start = end
            end += 2
            (_v406.value,) = _get_struct_H().unpack(str[start:end])
            _v407 = val7.horizontal_opening_angle_end
            start = end
            end += 2
            (_v407.value,) = _get_struct_H().unpack(str[start:end])
            _v408 = val7.vertical_opening_angle_start
            start = end
            end += 2
            (_v408.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
            _v409 = val7.vertical_opening_angle_end
            start = end
            end += 2
            (_v409.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
            _v404.array.append(val7)
          start = end
          end += 1
          (val3.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.perception_region_shape_is_present = bool(val3.perception_region_shape_is_present)
          _v410 = val3.perception_region_confidence
          start = end
          end += 1
          (_v410.value,) = _get_struct_B().unpack(str[start:end])
          _x = val3
          start = end
          end += 2
          (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
          val3.perception_region_confidence_is_present = bool(val3.perception_region_confidence_is_present)
          val3.shadowing_applies = bool(val3.shadowing_applies)
          _v350.array.append(val3)
        _v411 = val1.container_data_perception_region_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v411.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
          _v412 = val3.measurement_delta_time
          start = end
          end += 2
          (_v412.value,) = _get_struct_h().unpack(str[start:end])
          _v413 = val3.perception_region_confidence
          start = end
          end += 1
          (_v413.value,) = _get_struct_B().unpack(str[start:end])
          _v414 = val3.perception_region_shape
          start = end
          end += 1
          (_v414.choice,) = _get_struct_B().unpack(str[start:end])
          _v415 = _v414.rectangular
          _v416 = _v415.center_point
          _v417 = _v416.x_coordinate
          start = end
          end += 2
          (_v417.value,) = _get_struct_h().unpack(str[start:end])
          _v418 = _v416.y_coordinate
          start = end
          end += 2
          (_v418.value,) = _get_struct_h().unpack(str[start:end])
          _v419 = _v416.z_coordinate
          start = end
          end += 2
          (_v419.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v416.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v416.z_coordinate_is_present = bool(_v416.z_coordinate_is_present)
          start = end
          end += 1
          (_v415.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v415.center_point_is_present = bool(_v415.center_point_is_present)
          _v420 = _v415.semi_length
          start = end
          end += 2
          (_v420.value,) = _get_struct_H().unpack(str[start:end])
          _v421 = _v415.semi_breadth
          start = end
          end += 2
          (_v421.value,) = _get_struct_H().unpack(str[start:end])
          _v422 = _v415.orientation
          start = end
          end += 2
          (_v422.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v415.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v415.orientation_is_present = bool(_v415.orientation_is_present)
          _v423 = _v415.height
          start = end
          end += 2
          (_v423.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v415.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v415.height_is_present = bool(_v415.height_is_present)
          _v424 = _v414.circular
          _v425 = _v424.shape_reference_point
          _v426 = _v425.x_coordinate
          start = end
          end += 2
          (_v426.value,) = _get_struct_h().unpack(str[start:end])
          _v427 = _v425.y_coordinate
          start = end
          end += 2
          (_v427.value,) = _get_struct_h().unpack(str[start:end])
          _v428 = _v425.z_coordinate
          start = end
          end += 2
          (_v428.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v425.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v425.z_coordinate_is_present = bool(_v425.z_coordinate_is_present)
          start = end
          end += 1
          (_v424.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v424.shape_reference_point_is_present = bool(_v424.shape_reference_point_is_present)
          _v429 = _v424.radius
          start = end
          end += 2
          (_v429.value,) = _get_struct_H().unpack(str[start:end])
          _v430 = _v424.height
          start = end
          end += 2
          (_v430.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v424.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v424.height_is_present = bool(_v424.height_is_present)
          _v431 = _v414.polygonal
          _v432 = _v431.shape_reference_point
          _v433 = _v432.x_coordinate
          start = end
          end += 2
          (_v433.value,) = _get_struct_h().unpack(str[start:end])
          _v434 = _v432.y_coordinate
          start = end
          end += 2
          (_v434.value,) = _get_struct_h().unpack(str[start:end])
          _v435 = _v432.z_coordinate
          start = end
          end += 2
          (_v435.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v432.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v432.z_coordinate_is_present = bool(_v432.z_coordinate_is_present)
          start = end
          end += 1
          (_v431.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v431.shape_reference_point_is_present = bool(_v431.shape_reference_point_is_present)
          _v436 = _v431.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v436.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v437 = val7.x_coordinate
            start = end
            end += 2
            (_v437.value,) = _get_struct_h().unpack(str[start:end])
            _v438 = val7.y_coordinate
            start = end
            end += 2
            (_v438.value,) = _get_struct_h().unpack(str[start:end])
            _v439 = val7.z_coordinate
            start = end
            end += 2
            (_v439.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
            _v436.array.append(val7)
          _v440 = _v431.height
          start = end
          end += 2
          (_v440.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v431.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v431.height_is_present = bool(_v431.height_is_present)
          _v441 = _v414.elliptical
          _v442 = _v441.shape_reference_point
          _v443 = _v442.x_coordinate
          start = end
          end += 2
          (_v443.value,) = _get_struct_h().unpack(str[start:end])
          _v444 = _v442.y_coordinate
          start = end
          end += 2
          (_v444.value,) = _get_struct_h().unpack(str[start:end])
          _v445 = _v442.z_coordinate
          start = end
          end += 2
          (_v445.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v442.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v442.z_coordinate_is_present = bool(_v442.z_coordinate_is_present)
          start = end
          end += 1
          (_v441.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v441.shape_reference_point_is_present = bool(_v441.shape_reference_point_is_present)
          _v446 = _v441.semi_major_axis_length
          start = end
          end += 2
          (_v446.value,) = _get_struct_H().unpack(str[start:end])
          _v447 = _v441.semi_minor_axis_length
          start = end
          end += 2
          (_v447.value,) = _get_struct_H().unpack(str[start:end])
          _v448 = _v441.orientation
          start = end
          end += 2
          (_v448.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v441.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v441.orientation_is_present = bool(_v441.orientation_is_present)
          _v449 = _v441.height
          start = end
          end += 2
          (_v449.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v441.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v441.height_is_present = bool(_v441.height_is_present)
          _v450 = _v414.radial
          _v451 = _v450.shape_reference_point
          _v452 = _v451.x_coordinate
          start = end
          end += 2
          (_v452.value,) = _get_struct_h().unpack(str[start:end])
          _v453 = _v451.y_coordinate
          start = end
          end += 2
          (_v453.value,) = _get_struct_h().unpack(str[start:end])
          _v454 = _v451.z_coordinate
          start = end
          end += 2
          (_v454.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v451.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v451.z_coordinate_is_present = bool(_v451.z_coordinate_is_present)
          start = end
          end += 1
          (_v450.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v450.shape_reference_point_is_present = bool(_v450.shape_reference_point_is_present)
          _v455 = _v450.range
          start = end
          end += 2
          (_v455.value,) = _get_struct_H().unpack(str[start:end])
          _v456 = _v450.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v456.value,) = _get_struct_H().unpack(str[start:end])
          _v457 = _v450.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v457.value,) = _get_struct_H().unpack(str[start:end])
          _v458 = _v450.vertical_opening_angle_start
          start = end
          end += 2
          (_v458.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v450.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v450.vertical_opening_angle_start_is_present = bool(_v450.vertical_opening_angle_start_is_present)
          _v459 = _v450.vertical_opening_angle_end
          start = end
          end += 2
          (_v459.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v450.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v450.vertical_opening_angle_end_is_present = bool(_v450.vertical_opening_angle_end_is_present)
          _v460 = _v414.radial_shapes
          _v461 = _v460.ref_point_id
          start = end
          end += 1
          (_v461.value,) = _get_struct_B().unpack(str[start:end])
          _v462 = _v460.x_coordinate
          start = end
          end += 2
          (_v462.value,) = _get_struct_h().unpack(str[start:end])
          _v463 = _v460.y_coordinate
          start = end
          end += 2
          (_v463.value,) = _get_struct_h().unpack(str[start:end])
          _v464 = _v460.z_coordinate
          start = end
          end += 2
          (_v464.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v460.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v460.z_coordinate_is_present = bool(_v460.z_coordinate_is_present)
          _v465 = _v460.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v465.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v466 = val7.range
            start = end
            end += 2
            (_v466.value,) = _get_struct_H().unpack(str[start:end])
            _v467 = val7.horizontal_opening_angle_start
            start = end
            end += 2
            (_v467.value,) = _get_struct_H().unpack(str[start:end])
            _v468 = val7.horizontal_opening_angle_end
            start = end
            end += 2
            (_v468.value,) = _get_struct_H().unpack(str[start:end])
            _v469 = val7.vertical_opening_angle_start
            start = end
            end += 2
            (_v469.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
            _v470 = val7.vertical_opening_angle_end
            start = end
            end += 2
            (_v470.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
            _v465.array.append(val7)
          start = end
          end += 1
          (val3.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
          val3.shadowing_applies = bool(val3.shadowing_applies)
          _v471 = val3.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v471.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v471.array.append(val5)
          start = end
          end += 1
          (val3.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.sensor_id_list_is_present = bool(val3.sensor_id_list_is_present)
          _v472 = val3.number_of_perceived_objects
          start = end
          end += 1
          (_v472.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val3.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.number_of_perceived_objects_is_present = bool(val3.number_of_perceived_objects_is_present)
          _v473 = val3.perceived_object_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v473.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
            start = end
            end += 2
            (val5.value,) = _get_struct_H().unpack(str[start:end])
            _v473.array.append(val5)
          start = end
          end += 1
          (val3.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.perceived_object_ids_is_present = bool(val3.perceived_object_ids_is_present)
          _v411.array.append(val3)
        _v474 = val1.container_data_perceived_object_container
        _v475 = _v474.number_of_perceived_objects
        start = end
        end += 1
        (_v475.value,) = _get_struct_B().unpack(str[start:end])
        _v476 = _v474.perceived_objects
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v476.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
          _v477 = val4.object_id
          start = end
          end += 2
          (_v477.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_id_is_present = bool(val4.object_id_is_present)
          _v478 = val4.measurement_delta_time
          start = end
          end += 2
          (_v478.value,) = _get_struct_h().unpack(str[start:end])
          _v479 = val4.position
          _v480 = _v479.x_coordinate
          _v481 = _v480.value
          start = end
          end += 4
          (_v481.value,) = _get_struct_i().unpack(str[start:end])
          _v482 = _v480.confidence
          start = end
          end += 2
          (_v482.value,) = _get_struct_H().unpack(str[start:end])
          _v483 = _v479.y_coordinate
          _v484 = _v483.value
          start = end
          end += 4
          (_v484.value,) = _get_struct_i().unpack(str[start:end])
          _v485 = _v483.confidence
          start = end
          end += 2
          (_v485.value,) = _get_struct_H().unpack(str[start:end])
          _v486 = _v479.z_coordinate
          _v487 = _v486.value
          start = end
          end += 4
          (_v487.value,) = _get_struct_i().unpack(str[start:end])
          _v488 = _v486.confidence
          start = end
          end += 2
          (_v488.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v479.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v479.z_coordinate_is_present = bool(_v479.z_coordinate_is_present)
          _v489 = val4.velocity
          start = end
          end += 1
          (_v489.choice,) = _get_struct_B().unpack(str[start:end])
          _v490 = _v489.polar_velocity
          _v491 = _v490.velocity_magnitude
          _v492 = _v491.speed_value
          start = end
          end += 2
          (_v492.value,) = _get_struct_H().unpack(str[start:end])
          _v493 = _v491.speed_confidence
          start = end
          end += 1
          (_v493.value,) = _get_struct_B().unpack(str[start:end])
          _v494 = _v490.velocity_direction
          _v495 = _v494.value
          start = end
          end += 2
          (_v495.value,) = _get_struct_H().unpack(str[start:end])
          _v496 = _v494.confidence
          start = end
          end += 1
          (_v496.value,) = _get_struct_B().unpack(str[start:end])
          _v497 = _v490.z_velocity
          _v498 = _v497.value
          start = end
          end += 2
          (_v498.value,) = _get_struct_h().unpack(str[start:end])
          _v499 = _v497.confidence
          start = end
          end += 1
          (_v499.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v490.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v490.z_velocity_is_present = bool(_v490.z_velocity_is_present)
          _v500 = _v489.cartesian_velocity
          _v501 = _v500.x_velocity
          _v502 = _v501.value
          start = end
          end += 2
          (_v502.value,) = _get_struct_h().unpack(str[start:end])
          _v503 = _v501.confidence
          start = end
          end += 1
          (_v503.value,) = _get_struct_B().unpack(str[start:end])
          _v504 = _v500.y_velocity
          _v505 = _v504.value
          start = end
          end += 2
          (_v505.value,) = _get_struct_h().unpack(str[start:end])
          _v506 = _v504.confidence
          start = end
          end += 1
          (_v506.value,) = _get_struct_B().unpack(str[start:end])
          _v507 = _v500.z_velocity
          _v508 = _v507.value
          start = end
          end += 2
          (_v508.value,) = _get_struct_h().unpack(str[start:end])
          _v509 = _v507.confidence
          start = end
          end += 1
          (_v509.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v500.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v500.z_velocity_is_present = bool(_v500.z_velocity_is_present)
          start = end
          end += 1
          (val4.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.velocity_is_present = bool(val4.velocity_is_present)
          _v510 = val4.acceleration
          start = end
          end += 1
          (_v510.choice,) = _get_struct_B().unpack(str[start:end])
          _v511 = _v510.polar_acceleration
          _v512 = _v511.acceleration_magnitude
          _v513 = _v512.acceleration_magnitude_value
          start = end
          end += 1
          (_v513.value,) = _get_struct_B().unpack(str[start:end])
          _v514 = _v512.acceleration_confidence
          start = end
          end += 1
          (_v514.value,) = _get_struct_B().unpack(str[start:end])
          _v515 = _v511.acceleration_direction
          _v516 = _v515.value
          start = end
          end += 2
          (_v516.value,) = _get_struct_H().unpack(str[start:end])
          _v517 = _v515.confidence
          start = end
          end += 1
          (_v517.value,) = _get_struct_B().unpack(str[start:end])
          _v518 = _v511.z_acceleration
          _v519 = _v518.value
          start = end
          end += 2
          (_v519.value,) = _get_struct_h().unpack(str[start:end])
          _v520 = _v518.confidence
          start = end
          end += 1
          (_v520.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v511.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v511.z_acceleration_is_present = bool(_v511.z_acceleration_is_present)
          _v521 = _v510.cartesian_acceleration
          _v522 = _v521.x_acceleration
          _v523 = _v522.value
          start = end
          end += 2
          (_v523.value,) = _get_struct_h().unpack(str[start:end])
          _v524 = _v522.confidence
          start = end
          end += 1
          (_v524.value,) = _get_struct_B().unpack(str[start:end])
          _v525 = _v521.y_acceleration
          _v526 = _v525.value
          start = end
          end += 2
          (_v526.value,) = _get_struct_h().unpack(str[start:end])
          _v527 = _v525.confidence
          start = end
          end += 1
          (_v527.value,) = _get_struct_B().unpack(str[start:end])
          _v528 = _v521.z_acceleration
          _v529 = _v528.value
          start = end
          end += 2
          (_v529.value,) = _get_struct_h().unpack(str[start:end])
          _v530 = _v528.confidence
          start = end
          end += 1
          (_v530.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v521.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v521.z_acceleration_is_present = bool(_v521.z_acceleration_is_present)
          start = end
          end += 1
          (val4.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.acceleration_is_present = bool(val4.acceleration_is_present)
          _v531 = val4.angles
          _v532 = _v531.z_angle
          _v533 = _v532.value
          start = end
          end += 2
          (_v533.value,) = _get_struct_H().unpack(str[start:end])
          _v534 = _v532.confidence
          start = end
          end += 1
          (_v534.value,) = _get_struct_B().unpack(str[start:end])
          _v535 = _v531.y_angle
          _v536 = _v535.value
          start = end
          end += 2
          (_v536.value,) = _get_struct_H().unpack(str[start:end])
          _v537 = _v535.confidence
          start = end
          end += 1
          (_v537.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v531.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v531.y_angle_is_present = bool(_v531.y_angle_is_present)
          _v538 = _v531.x_angle
          _v539 = _v538.value
          start = end
          end += 2
          (_v539.value,) = _get_struct_H().unpack(str[start:end])
          _v540 = _v538.confidence
          start = end
          end += 1
          (_v540.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v531.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v531.x_angle_is_present = bool(_v531.x_angle_is_present)
          start = end
          end += 1
          (val4.angles_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.angles_is_present = bool(val4.angles_is_present)
          _v541 = val4.z_angular_velocity
          _v542 = _v541.value
          start = end
          end += 2
          (_v542.value,) = _get_struct_h().unpack(str[start:end])
          _v543 = _v541.confidence
          start = end
          end += 1
          (_v543.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.z_angular_velocity_is_present = bool(val4.z_angular_velocity_is_present)
          _v544 = val4.lower_triangular_correlation_matrices
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v544.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
            _v545 = val6.components_included_inthe_matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v545.value = str[start:end]
            start = end
            end += 1
            (_v545.bits_unused,) = _get_struct_B().unpack(str[start:end])
            _v546 = val6.matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v546.array = []
            for i in range(0, length):
              val8 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              val8.array = []
              for i in range(0, length):
                val9 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
                start = end
                end += 1
                (val9.value,) = _get_struct_b().unpack(str[start:end])
                val8.array.append(val9)
              _v546.array.append(val8)
            _v544.array.append(val6)
          start = end
          end += 1
          (val4.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.lower_triangular_correlation_matrices_is_present = bool(val4.lower_triangular_correlation_matrices_is_present)
          _v547 = val4.object_dimension_z
          _v548 = _v547.value
          start = end
          end += 2
          (_v548.value,) = _get_struct_H().unpack(str[start:end])
          _v549 = _v547.confidence
          start = end
          end += 1
          (_v549.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_z_is_present = bool(val4.object_dimension_z_is_present)
          _v550 = val4.object_dimension_y
          _v551 = _v550.value
          start = end
          end += 2
          (_v551.value,) = _get_struct_H().unpack(str[start:end])
          _v552 = _v550.confidence
          start = end
          end += 1
          (_v552.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_y_is_present = bool(val4.object_dimension_y_is_present)
          _v553 = val4.object_dimension_x
          _v554 = _v553.value
          start = end
          end += 2
          (_v554.value,) = _get_struct_H().unpack(str[start:end])
          _v555 = _v553.confidence
          start = end
          end += 1
          (_v555.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_x_is_present = bool(val4.object_dimension_x_is_present)
          _v556 = val4.object_age
          start = end
          end += 2
          (_v556.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_age_is_present = bool(val4.object_age_is_present)
          _v557 = val4.object_perception_quality
          start = end
          end += 1
          (_v557.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_perception_quality_is_present = bool(val4.object_perception_quality_is_present)
          _v558 = val4.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v558.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val6.value,) = _get_struct_B().unpack(str[start:end])
            _v558.array.append(val6)
          start = end
          end += 1
          (val4.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.sensor_id_list_is_present = bool(val4.sensor_id_list_is_present)
          _v559 = val4.classification
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v559.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
            _v560 = val6.object_class
            start = end
            end += 1
            (_v560.choice,) = _get_struct_B().unpack(str[start:end])
            _v561 = _v560.vehicle_sub_class
            start = end
            end += 1
            (_v561.value,) = _get_struct_B().unpack(str[start:end])
            _v562 = _v560.vru_sub_class
            start = end
            end += 1
            (_v562.choice,) = _get_struct_B().unpack(str[start:end])
            _v563 = _v562.pedestrian
            start = end
            end += 1
            (_v563.value,) = _get_struct_B().unpack(str[start:end])
            _v564 = _v562.bicyclist_and_light_vru_vehicle
            start = end
            end += 1
            (_v564.value,) = _get_struct_B().unpack(str[start:end])
            _v565 = _v562.motorcyclist
            start = end
            end += 1
            (_v565.value,) = _get_struct_B().unpack(str[start:end])
            _v566 = _v562.animal
            start = end
            end += 1
            (_v566.value,) = _get_struct_B().unpack(str[start:end])
            _v567 = _v560.group_sub_class
            _v568 = _v567.cluster_id
            start = end
            end += 1
            (_v568.value,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v567.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
            _v567.cluster_id_is_present = bool(_v567.cluster_id_is_present)
            _v569 = _v567.cluster_bounding_box_shape
            start = end
            end += 1
            (_v569.choice,) = _get_struct_B().unpack(str[start:end])
            _v570 = _v569.rectangular
            _v571 = _v570.center_point
            _v572 = _v571.x_coordinate
            start = end
            end += 2
            (_v572.value,) = _get_struct_h().unpack(str[start:end])
            _v573 = _v571.y_coordinate
            start = end
            end += 2
            (_v573.value,) = _get_struct_h().unpack(str[start:end])
            _v574 = _v571.z_coordinate
            start = end
            end += 2
            (_v574.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v571.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v571.z_coordinate_is_present = bool(_v571.z_coordinate_is_present)
            start = end
            end += 1
            (_v570.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v570.center_point_is_present = bool(_v570.center_point_is_present)
            _v575 = _v570.semi_length
            start = end
            end += 2
            (_v575.value,) = _get_struct_H().unpack(str[start:end])
            _v576 = _v570.semi_breadth
            start = end
            end += 2
            (_v576.value,) = _get_struct_H().unpack(str[start:end])
            _v577 = _v570.orientation
            start = end
            end += 2
            (_v577.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v570.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v570.orientation_is_present = bool(_v570.orientation_is_present)
            _v578 = _v570.height
            start = end
            end += 2
            (_v578.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v570.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v570.height_is_present = bool(_v570.height_is_present)
            _v579 = _v569.circular
            _v580 = _v579.shape_reference_point
            _v581 = _v580.x_coordinate
            start = end
            end += 2
            (_v581.value,) = _get_struct_h().unpack(str[start:end])
            _v582 = _v580.y_coordinate
            start = end
            end += 2
            (_v582.value,) = _get_struct_h().unpack(str[start:end])
            _v583 = _v580.z_coordinate
            start = end
            end += 2
            (_v583.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v580.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v580.z_coordinate_is_present = bool(_v580.z_coordinate_is_present)
            start = end
            end += 1
            (_v579.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v579.shape_reference_point_is_present = bool(_v579.shape_reference_point_is_present)
            _v584 = _v579.radius
            start = end
            end += 2
            (_v584.value,) = _get_struct_H().unpack(str[start:end])
            _v585 = _v579.height
            start = end
            end += 2
            (_v585.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v579.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v579.height_is_present = bool(_v579.height_is_present)
            _v586 = _v569.polygonal
            _v587 = _v586.shape_reference_point
            _v588 = _v587.x_coordinate
            start = end
            end += 2
            (_v588.value,) = _get_struct_h().unpack(str[start:end])
            _v589 = _v587.y_coordinate
            start = end
            end += 2
            (_v589.value,) = _get_struct_h().unpack(str[start:end])
            _v590 = _v587.z_coordinate
            start = end
            end += 2
            (_v590.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v587.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v587.z_coordinate_is_present = bool(_v587.z_coordinate_is_present)
            start = end
            end += 1
            (_v586.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v586.shape_reference_point_is_present = bool(_v586.shape_reference_point_is_present)
            _v591 = _v586.polygon
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v591.array = []
            for i in range(0, length):
              val12 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
              _v592 = val12.x_coordinate
              start = end
              end += 2
              (_v592.value,) = _get_struct_h().unpack(str[start:end])
              _v593 = val12.y_coordinate
              start = end
              end += 2
              (_v593.value,) = _get_struct_h().unpack(str[start:end])
              _v594 = val12.z_coordinate
              start = end
              end += 2
              (_v594.value,) = _get_struct_h().unpack(str[start:end])
              start = end
              end += 1
              (val12.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.z_coordinate_is_present = bool(val12.z_coordinate_is_present)
              _v591.array.append(val12)
            _v595 = _v586.height
            start = end
            end += 2
            (_v595.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v586.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v586.height_is_present = bool(_v586.height_is_present)
            _v596 = _v569.elliptical
            _v597 = _v596.shape_reference_point
            _v598 = _v597.x_coordinate
            start = end
            end += 2
            (_v598.value,) = _get_struct_h().unpack(str[start:end])
            _v599 = _v597.y_coordinate
            start = end
            end += 2
            (_v599.value,) = _get_struct_h().unpack(str[start:end])
            _v600 = _v597.z_coordinate
            start = end
            end += 2
            (_v600.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v597.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v597.z_coordinate_is_present = bool(_v597.z_coordinate_is_present)
            start = end
            end += 1
            (_v596.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v596.shape_reference_point_is_present = bool(_v596.shape_reference_point_is_present)
            _v601 = _v596.semi_major_axis_length
            start = end
            end += 2
            (_v601.value,) = _get_struct_H().unpack(str[start:end])
            _v602 = _v596.semi_minor_axis_length
            start = end
            end += 2
            (_v602.value,) = _get_struct_H().unpack(str[start:end])
            _v603 = _v596.orientation
            start = end
            end += 2
            (_v603.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v596.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v596.orientation_is_present = bool(_v596.orientation_is_present)
            _v604 = _v596.height
            start = end
            end += 2
            (_v604.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v596.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v596.height_is_present = bool(_v596.height_is_present)
            _v605 = _v569.radial
            _v606 = _v605.shape_reference_point
            _v607 = _v606.x_coordinate
            start = end
            end += 2
            (_v607.value,) = _get_struct_h().unpack(str[start:end])
            _v608 = _v606.y_coordinate
            start = end
            end += 2
            (_v608.value,) = _get_struct_h().unpack(str[start:end])
            _v609 = _v606.z_coordinate
            start = end
            end += 2
            (_v609.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v606.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v606.z_coordinate_is_present = bool(_v606.z_coordinate_is_present)
            start = end
            end += 1
            (_v605.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v605.shape_reference_point_is_present = bool(_v605.shape_reference_point_is_present)
            _v610 = _v605.range
            start = end
            end += 2
            (_v610.value,) = _get_struct_H().unpack(str[start:end])
            _v611 = _v605.stationary_horizontal_opening_angle_start
            start = end
            end += 2
            (_v611.value,) = _get_struct_H().unpack(str[start:end])
            _v612 = _v605.stationary_horizontal_opening_angle_end
            start = end
            end += 2
            (_v612.value,) = _get_struct_H().unpack(str[start:end])
            _v613 = _v605.vertical_opening_angle_start
            start = end
            end += 2
            (_v613.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v605.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            _v605.vertical_opening_angle_start_is_present = bool(_v605.vertical_opening_angle_start_is_present)
            _v614 = _v605.vertical_opening_angle_end
            start = end
            end += 2
            (_v614.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v605.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            _v605.vertical_opening_angle_end_is_present = bool(_v605.vertical_opening_angle_end_is_present)
            _v615 = _v569.radial_shapes
            _v616 = _v615.ref_point_id
            start = end
            end += 1
            (_v616.value,) = _get_struct_B().unpack(str[start:end])
            _v617 = _v615.x_coordinate
            start = end
            end += 2
            (_v617.value,) = _get_struct_h().unpack(str[start:end])
            _v618 = _v615.y_coordinate
            start = end
            end += 2
            (_v618.value,) = _get_struct_h().unpack(str[start:end])
            _v619 = _v615.z_coordinate
            start = end
            end += 2
            (_v619.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v615.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v615.z_coordinate_is_present = bool(_v615.z_coordinate_is_present)
            _v620 = _v615.radial_shapes_list
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v620.array = []
            for i in range(0, length):
              val12 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
              _v621 = val12.range
              start = end
              end += 2
              (_v621.value,) = _get_struct_H().unpack(str[start:end])
              _v622 = val12.horizontal_opening_angle_start
              start = end
              end += 2
              (_v622.value,) = _get_struct_H().unpack(str[start:end])
              _v623 = val12.horizontal_opening_angle_end
              start = end
              end += 2
              (_v623.value,) = _get_struct_H().unpack(str[start:end])
              _v624 = val12.vertical_opening_angle_start
              start = end
              end += 2
              (_v624.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val12.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.vertical_opening_angle_start_is_present = bool(val12.vertical_opening_angle_start_is_present)
              _v625 = val12.vertical_opening_angle_end
              start = end
              end += 2
              (_v625.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val12.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.vertical_opening_angle_end_is_present = bool(val12.vertical_opening_angle_end_is_present)
              _v620.array.append(val12)
            start = end
            end += 1
            (_v567.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
            _v567.cluster_bounding_box_shape_is_present = bool(_v567.cluster_bounding_box_shape_is_present)
            _v626 = _v567.cluster_cardinality_size
            start = end
            end += 1
            (_v626.value,) = _get_struct_B().unpack(str[start:end])
            _v627 = _v567.cluster_profiles
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v627.value = str[start:end]
            start = end
            end += 1
            (_v627.bits_unused,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v567.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
            _v567.cluster_profiles_is_present = bool(_v567.cluster_profiles_is_present)
            _v628 = _v560.other_sub_class
            start = end
            end += 1
            (_v628.value,) = _get_struct_B().unpack(str[start:end])
            _v629 = val6.confidence
            start = end
            end += 1
            (_v629.value,) = _get_struct_B().unpack(str[start:end])
            _v559.array.append(val6)
          start = end
          end += 1
          (val4.classification_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.classification_is_present = bool(val4.classification_is_present)
          _v630 = val4.map_position
          _v631 = _v630.map_reference
          start = end
          end += 1
          (_v631.choice,) = _get_struct_B().unpack(str[start:end])
          _v632 = _v631.roadsegment
          _v633 = _v632.region
          start = end
          end += 2
          (_v633.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v632.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v632.region_is_present = bool(_v632.region_is_present)
          _v634 = _v632.id
          start = end
          end += 2
          (_v634.value,) = _get_struct_H().unpack(str[start:end])
          _v635 = _v631.intersection
          _v636 = _v635.region
          start = end
          end += 2
          (_v636.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v635.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v635.region_is_present = bool(_v635.region_is_present)
          _v637 = _v635.id
          start = end
          end += 2
          (_v637.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v630.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          _v630.map_reference_is_present = bool(_v630.map_reference_is_present)
          _v638 = _v630.lane_id
          start = end
          end += 1
          (_v638.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v630.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v630.lane_id_is_present = bool(_v630.lane_id_is_present)
          _v639 = _v630.connection_id
          start = end
          end += 1
          (_v639.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v630.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v630.connection_id_is_present = bool(_v630.connection_id_is_present)
          _v640 = _v630.longitudinal_lane_position
          _v641 = _v640.longitudinal_lane_position_value
          start = end
          end += 2
          (_v641.value,) = _get_struct_H().unpack(str[start:end])
          _v642 = _v640.longitudinal_lane_position_confidence
          start = end
          end += 2
          (_v642.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v630.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
          _v630.longitudinal_lane_position_is_present = bool(_v630.longitudinal_lane_position_is_present)
          start = end
          end += 1
          (val4.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.map_position_is_present = bool(val4.map_position_is_present)
          _v476.array.append(val4)
        self.cpm_containers.value.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2i3Hi5BbBbB().pack(_x.management_container.reference_time.value, _x.management_container.reference_position.latitude.value, _x.management_container.reference_position.longitude.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_minor_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_orientation.value, _x.management_container.reference_position.altitude.altitude_value.value, _x.management_container.reference_position.altitude.altitude_confidence.value, _x.management_container.segmentation_info.total_msg_no.value, _x.management_container.segmentation_info.this_msg_no.value, _x.management_container.segmentation_info_is_present, _x.management_container.message_rate_range.message_rate_min.mantissa, _x.management_container.message_rate_range.message_rate_min.exponent, _x.management_container.message_rate_range.message_rate_max.mantissa, _x.management_container.message_rate_range.message_rate_max.exponent, _x.management_container.message_rate_range_is_present))
      length = len(self.cpm_containers.value.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.cpm_containers.value.array:
        _v643 = val1.container_id
        _x = _v643.value
        buff.write(_get_struct_B().pack(_x))
        _v644 = val1.container_data_originating_vehicle_container
        _v645 = _v644.orientation_angle
        _v646 = _v645.value
        _x = _v646.value
        buff.write(_get_struct_H().pack(_x))
        _v647 = _v645.confidence
        _x = _v647.value
        buff.write(_get_struct_B().pack(_x))
        _v648 = _v644.pitch_angle
        _v649 = _v648.value
        _x = _v649.value
        buff.write(_get_struct_H().pack(_x))
        _v650 = _v648.confidence
        _x = _v650.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v644.pitch_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v651 = _v644.roll_angle
        _v652 = _v651.value
        _x = _v652.value
        buff.write(_get_struct_H().pack(_x))
        _v653 = _v651.confidence
        _x = _v653.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v644.roll_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v654 = _v644.trailer_data_set
        length = len(_v654.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v654.array:
          _v655 = val4.ref_point_id
          _x = _v655.value
          buff.write(_get_struct_B().pack(_x))
          _v656 = val4.hitch_point_offset
          _x = _v656.value
          buff.write(_get_struct_B().pack(_x))
          _v657 = val4.front_overhang
          _x = _v657.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.front_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v658 = val4.rear_overhang
          _x = _v658.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.rear_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v659 = val4.trailer_width
          _x = _v659.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.trailer_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v660 = val4.hitch_angle
          _v661 = _v660.value
          _x = _v661.value
          buff.write(_get_struct_H().pack(_x))
          _v662 = _v660.confidence
          _x = _v662.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v644.trailer_data_set_is_present
        buff.write(_get_struct_B().pack(_x))
        _v663 = val1.container_data_originating_rsu_container
        _v664 = _v663.map_reference
        _x = _v664.choice
        buff.write(_get_struct_B().pack(_x))
        _v665 = _v664.roadsegment
        _v666 = _v665.region
        _x = _v666.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v665.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v667 = _v665.id
        _x = _v667.value
        buff.write(_get_struct_H().pack(_x))
        _v668 = _v664.intersection
        _v669 = _v668.region
        _x = _v669.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v668.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v670 = _v668.id
        _x = _v670.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v663.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v671 = val1.container_data_sensor_information_container
        length = len(_v671.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v671.array:
          _v672 = val3.sensor_id
          _x = _v672.value
          buff.write(_get_struct_B().pack(_x))
          _v673 = val3.sensor_type
          _x = _v673.value
          buff.write(_get_struct_B().pack(_x))
          _v674 = val3.perception_region_shape
          _x = _v674.choice
          buff.write(_get_struct_B().pack(_x))
          _v675 = _v674.rectangular
          _v676 = _v675.center_point
          _v677 = _v676.x_coordinate
          _x = _v677.value
          buff.write(_get_struct_h().pack(_x))
          _v678 = _v676.y_coordinate
          _x = _v678.value
          buff.write(_get_struct_h().pack(_x))
          _v679 = _v676.z_coordinate
          _x = _v679.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v676.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v675.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v680 = _v675.semi_length
          _x = _v680.value
          buff.write(_get_struct_H().pack(_x))
          _v681 = _v675.semi_breadth
          _x = _v681.value
          buff.write(_get_struct_H().pack(_x))
          _v682 = _v675.orientation
          _x = _v682.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v675.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v683 = _v675.height
          _x = _v683.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v675.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v684 = _v674.circular
          _v685 = _v684.shape_reference_point
          _v686 = _v685.x_coordinate
          _x = _v686.value
          buff.write(_get_struct_h().pack(_x))
          _v687 = _v685.y_coordinate
          _x = _v687.value
          buff.write(_get_struct_h().pack(_x))
          _v688 = _v685.z_coordinate
          _x = _v688.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v685.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v684.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v689 = _v684.radius
          _x = _v689.value
          buff.write(_get_struct_H().pack(_x))
          _v690 = _v684.height
          _x = _v690.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v684.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v691 = _v674.polygonal
          _v692 = _v691.shape_reference_point
          _v693 = _v692.x_coordinate
          _x = _v693.value
          buff.write(_get_struct_h().pack(_x))
          _v694 = _v692.y_coordinate
          _x = _v694.value
          buff.write(_get_struct_h().pack(_x))
          _v695 = _v692.z_coordinate
          _x = _v695.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v692.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v691.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v696 = _v691.polygon
          length = len(_v696.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v696.array:
            _v697 = val7.x_coordinate
            _x = _v697.value
            buff.write(_get_struct_h().pack(_x))
            _v698 = val7.y_coordinate
            _x = _v698.value
            buff.write(_get_struct_h().pack(_x))
            _v699 = val7.z_coordinate
            _x = _v699.value
            buff.write(_get_struct_h().pack(_x))
            _x = val7.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v700 = _v691.height
          _x = _v700.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v691.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v701 = _v674.elliptical
          _v702 = _v701.shape_reference_point
          _v703 = _v702.x_coordinate
          _x = _v703.value
          buff.write(_get_struct_h().pack(_x))
          _v704 = _v702.y_coordinate
          _x = _v704.value
          buff.write(_get_struct_h().pack(_x))
          _v705 = _v702.z_coordinate
          _x = _v705.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v702.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v701.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v706 = _v701.semi_major_axis_length
          _x = _v706.value
          buff.write(_get_struct_H().pack(_x))
          _v707 = _v701.semi_minor_axis_length
          _x = _v707.value
          buff.write(_get_struct_H().pack(_x))
          _v708 = _v701.orientation
          _x = _v708.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v701.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v709 = _v701.height
          _x = _v709.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v701.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v710 = _v674.radial
          _v711 = _v710.shape_reference_point
          _v712 = _v711.x_coordinate
          _x = _v712.value
          buff.write(_get_struct_h().pack(_x))
          _v713 = _v711.y_coordinate
          _x = _v713.value
          buff.write(_get_struct_h().pack(_x))
          _v714 = _v711.z_coordinate
          _x = _v714.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v711.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v710.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v715 = _v710.range
          _x = _v715.value
          buff.write(_get_struct_H().pack(_x))
          _v716 = _v710.stationary_horizontal_opening_angle_start
          _x = _v716.value
          buff.write(_get_struct_H().pack(_x))
          _v717 = _v710.stationary_horizontal_opening_angle_end
          _x = _v717.value
          buff.write(_get_struct_H().pack(_x))
          _v718 = _v710.vertical_opening_angle_start
          _x = _v718.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v710.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v719 = _v710.vertical_opening_angle_end
          _x = _v719.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v710.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v720 = _v674.radial_shapes
          _v721 = _v720.ref_point_id
          _x = _v721.value
          buff.write(_get_struct_B().pack(_x))
          _v722 = _v720.x_coordinate
          _x = _v722.value
          buff.write(_get_struct_h().pack(_x))
          _v723 = _v720.y_coordinate
          _x = _v723.value
          buff.write(_get_struct_h().pack(_x))
          _v724 = _v720.z_coordinate
          _x = _v724.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v720.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v725 = _v720.radial_shapes_list
          length = len(_v725.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v725.array:
            _v726 = val7.range
            _x = _v726.value
            buff.write(_get_struct_H().pack(_x))
            _v727 = val7.horizontal_opening_angle_start
            _x = _v727.value
            buff.write(_get_struct_H().pack(_x))
            _v728 = val7.horizontal_opening_angle_end
            _x = _v728.value
            buff.write(_get_struct_H().pack(_x))
            _v729 = val7.vertical_opening_angle_start
            _x = _v729.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v730 = val7.vertical_opening_angle_end
            _x = _v730.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val3.perception_region_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v731 = val3.perception_region_confidence
          _x = _v731.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3
          buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
        _v732 = val1.container_data_perception_region_container
        length = len(_v732.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v732.array:
          _v733 = val3.measurement_delta_time
          _x = _v733.value
          buff.write(_get_struct_h().pack(_x))
          _v734 = val3.perception_region_confidence
          _x = _v734.value
          buff.write(_get_struct_B().pack(_x))
          _v735 = val3.perception_region_shape
          _x = _v735.choice
          buff.write(_get_struct_B().pack(_x))
          _v736 = _v735.rectangular
          _v737 = _v736.center_point
          _v738 = _v737.x_coordinate
          _x = _v738.value
          buff.write(_get_struct_h().pack(_x))
          _v739 = _v737.y_coordinate
          _x = _v739.value
          buff.write(_get_struct_h().pack(_x))
          _v740 = _v737.z_coordinate
          _x = _v740.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v737.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v736.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v741 = _v736.semi_length
          _x = _v741.value
          buff.write(_get_struct_H().pack(_x))
          _v742 = _v736.semi_breadth
          _x = _v742.value
          buff.write(_get_struct_H().pack(_x))
          _v743 = _v736.orientation
          _x = _v743.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v736.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v744 = _v736.height
          _x = _v744.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v736.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v745 = _v735.circular
          _v746 = _v745.shape_reference_point
          _v747 = _v746.x_coordinate
          _x = _v747.value
          buff.write(_get_struct_h().pack(_x))
          _v748 = _v746.y_coordinate
          _x = _v748.value
          buff.write(_get_struct_h().pack(_x))
          _v749 = _v746.z_coordinate
          _x = _v749.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v746.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v745.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v750 = _v745.radius
          _x = _v750.value
          buff.write(_get_struct_H().pack(_x))
          _v751 = _v745.height
          _x = _v751.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v745.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v752 = _v735.polygonal
          _v753 = _v752.shape_reference_point
          _v754 = _v753.x_coordinate
          _x = _v754.value
          buff.write(_get_struct_h().pack(_x))
          _v755 = _v753.y_coordinate
          _x = _v755.value
          buff.write(_get_struct_h().pack(_x))
          _v756 = _v753.z_coordinate
          _x = _v756.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v753.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v752.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v757 = _v752.polygon
          length = len(_v757.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v757.array:
            _v758 = val7.x_coordinate
            _x = _v758.value
            buff.write(_get_struct_h().pack(_x))
            _v759 = val7.y_coordinate
            _x = _v759.value
            buff.write(_get_struct_h().pack(_x))
            _v760 = val7.z_coordinate
            _x = _v760.value
            buff.write(_get_struct_h().pack(_x))
            _x = val7.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v761 = _v752.height
          _x = _v761.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v752.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v762 = _v735.elliptical
          _v763 = _v762.shape_reference_point
          _v764 = _v763.x_coordinate
          _x = _v764.value
          buff.write(_get_struct_h().pack(_x))
          _v765 = _v763.y_coordinate
          _x = _v765.value
          buff.write(_get_struct_h().pack(_x))
          _v766 = _v763.z_coordinate
          _x = _v766.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v763.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v762.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v767 = _v762.semi_major_axis_length
          _x = _v767.value
          buff.write(_get_struct_H().pack(_x))
          _v768 = _v762.semi_minor_axis_length
          _x = _v768.value
          buff.write(_get_struct_H().pack(_x))
          _v769 = _v762.orientation
          _x = _v769.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v762.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v770 = _v762.height
          _x = _v770.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v762.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v771 = _v735.radial
          _v772 = _v771.shape_reference_point
          _v773 = _v772.x_coordinate
          _x = _v773.value
          buff.write(_get_struct_h().pack(_x))
          _v774 = _v772.y_coordinate
          _x = _v774.value
          buff.write(_get_struct_h().pack(_x))
          _v775 = _v772.z_coordinate
          _x = _v775.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v772.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v771.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v776 = _v771.range
          _x = _v776.value
          buff.write(_get_struct_H().pack(_x))
          _v777 = _v771.stationary_horizontal_opening_angle_start
          _x = _v777.value
          buff.write(_get_struct_H().pack(_x))
          _v778 = _v771.stationary_horizontal_opening_angle_end
          _x = _v778.value
          buff.write(_get_struct_H().pack(_x))
          _v779 = _v771.vertical_opening_angle_start
          _x = _v779.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v771.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v780 = _v771.vertical_opening_angle_end
          _x = _v780.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v771.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v781 = _v735.radial_shapes
          _v782 = _v781.ref_point_id
          _x = _v782.value
          buff.write(_get_struct_B().pack(_x))
          _v783 = _v781.x_coordinate
          _x = _v783.value
          buff.write(_get_struct_h().pack(_x))
          _v784 = _v781.y_coordinate
          _x = _v784.value
          buff.write(_get_struct_h().pack(_x))
          _v785 = _v781.z_coordinate
          _x = _v785.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v781.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v786 = _v781.radial_shapes_list
          length = len(_v786.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v786.array:
            _v787 = val7.range
            _x = _v787.value
            buff.write(_get_struct_H().pack(_x))
            _v788 = val7.horizontal_opening_angle_start
            _x = _v788.value
            buff.write(_get_struct_H().pack(_x))
            _v789 = val7.horizontal_opening_angle_end
            _x = _v789.value
            buff.write(_get_struct_H().pack(_x))
            _v790 = val7.vertical_opening_angle_start
            _x = _v790.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v791 = val7.vertical_opening_angle_end
            _x = _v791.value
            buff.write(_get_struct_H().pack(_x))
            _x = val7.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val3.shadowing_applies
          buff.write(_get_struct_B().pack(_x))
          _v792 = val3.sensor_id_list
          length = len(_v792.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v792.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v793 = val3.number_of_perceived_objects
          _x = _v793.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3.number_of_perceived_objects_is_present
          buff.write(_get_struct_B().pack(_x))
          _v794 = val3.perceived_object_ids
          length = len(_v794.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v794.array:
            _x = val5.value
            buff.write(_get_struct_H().pack(_x))
          _x = val3.perceived_object_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _v795 = val1.container_data_perceived_object_container
        _v796 = _v795.number_of_perceived_objects
        _x = _v796.value
        buff.write(_get_struct_B().pack(_x))
        _v797 = _v795.perceived_objects
        length = len(_v797.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v797.array:
          _v798 = val4.object_id
          _x = _v798.value
          buff.write(_get_struct_H().pack(_x))
          _x = val4.object_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v799 = val4.measurement_delta_time
          _x = _v799.value
          buff.write(_get_struct_h().pack(_x))
          _v800 = val4.position
          _v801 = _v800.x_coordinate
          _v802 = _v801.value
          _x = _v802.value
          buff.write(_get_struct_i().pack(_x))
          _v803 = _v801.confidence
          _x = _v803.value
          buff.write(_get_struct_H().pack(_x))
          _v804 = _v800.y_coordinate
          _v805 = _v804.value
          _x = _v805.value
          buff.write(_get_struct_i().pack(_x))
          _v806 = _v804.confidence
          _x = _v806.value
          buff.write(_get_struct_H().pack(_x))
          _v807 = _v800.z_coordinate
          _v808 = _v807.value
          _x = _v808.value
          buff.write(_get_struct_i().pack(_x))
          _v809 = _v807.confidence
          _x = _v809.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v800.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v810 = val4.velocity
          _x = _v810.choice
          buff.write(_get_struct_B().pack(_x))
          _v811 = _v810.polar_velocity
          _v812 = _v811.velocity_magnitude
          _v813 = _v812.speed_value
          _x = _v813.value
          buff.write(_get_struct_H().pack(_x))
          _v814 = _v812.speed_confidence
          _x = _v814.value
          buff.write(_get_struct_B().pack(_x))
          _v815 = _v811.velocity_direction
          _v816 = _v815.value
          _x = _v816.value
          buff.write(_get_struct_H().pack(_x))
          _v817 = _v815.confidence
          _x = _v817.value
          buff.write(_get_struct_B().pack(_x))
          _v818 = _v811.z_velocity
          _v819 = _v818.value
          _x = _v819.value
          buff.write(_get_struct_h().pack(_x))
          _v820 = _v818.confidence
          _x = _v820.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v811.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v821 = _v810.cartesian_velocity
          _v822 = _v821.x_velocity
          _v823 = _v822.value
          _x = _v823.value
          buff.write(_get_struct_h().pack(_x))
          _v824 = _v822.confidence
          _x = _v824.value
          buff.write(_get_struct_B().pack(_x))
          _v825 = _v821.y_velocity
          _v826 = _v825.value
          _x = _v826.value
          buff.write(_get_struct_h().pack(_x))
          _v827 = _v825.confidence
          _x = _v827.value
          buff.write(_get_struct_B().pack(_x))
          _v828 = _v821.z_velocity
          _v829 = _v828.value
          _x = _v829.value
          buff.write(_get_struct_h().pack(_x))
          _v830 = _v828.confidence
          _x = _v830.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v821.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v831 = val4.acceleration
          _x = _v831.choice
          buff.write(_get_struct_B().pack(_x))
          _v832 = _v831.polar_acceleration
          _v833 = _v832.acceleration_magnitude
          _v834 = _v833.acceleration_magnitude_value
          _x = _v834.value
          buff.write(_get_struct_B().pack(_x))
          _v835 = _v833.acceleration_confidence
          _x = _v835.value
          buff.write(_get_struct_B().pack(_x))
          _v836 = _v832.acceleration_direction
          _v837 = _v836.value
          _x = _v837.value
          buff.write(_get_struct_H().pack(_x))
          _v838 = _v836.confidence
          _x = _v838.value
          buff.write(_get_struct_B().pack(_x))
          _v839 = _v832.z_acceleration
          _v840 = _v839.value
          _x = _v840.value
          buff.write(_get_struct_h().pack(_x))
          _v841 = _v839.confidence
          _x = _v841.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v832.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v842 = _v831.cartesian_acceleration
          _v843 = _v842.x_acceleration
          _v844 = _v843.value
          _x = _v844.value
          buff.write(_get_struct_h().pack(_x))
          _v845 = _v843.confidence
          _x = _v845.value
          buff.write(_get_struct_B().pack(_x))
          _v846 = _v842.y_acceleration
          _v847 = _v846.value
          _x = _v847.value
          buff.write(_get_struct_h().pack(_x))
          _v848 = _v846.confidence
          _x = _v848.value
          buff.write(_get_struct_B().pack(_x))
          _v849 = _v842.z_acceleration
          _v850 = _v849.value
          _x = _v850.value
          buff.write(_get_struct_h().pack(_x))
          _v851 = _v849.confidence
          _x = _v851.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v842.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v852 = val4.angles
          _v853 = _v852.z_angle
          _v854 = _v853.value
          _x = _v854.value
          buff.write(_get_struct_H().pack(_x))
          _v855 = _v853.confidence
          _x = _v855.value
          buff.write(_get_struct_B().pack(_x))
          _v856 = _v852.y_angle
          _v857 = _v856.value
          _x = _v857.value
          buff.write(_get_struct_H().pack(_x))
          _v858 = _v856.confidence
          _x = _v858.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v852.y_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _v859 = _v852.x_angle
          _v860 = _v859.value
          _x = _v860.value
          buff.write(_get_struct_H().pack(_x))
          _v861 = _v859.confidence
          _x = _v861.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v852.x_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.angles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v862 = val4.z_angular_velocity
          _v863 = _v862.value
          _x = _v863.value
          buff.write(_get_struct_h().pack(_x))
          _v864 = _v862.confidence
          _x = _v864.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.z_angular_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v865 = val4.lower_triangular_correlation_matrices
          length = len(_v865.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v865.array:
            _v866 = val6.components_included_inthe_matrix
            _x = _v866.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v866.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _v867 = val6.matrix
            length = len(_v867.array)
            buff.write(_struct_I.pack(length))
            for val8 in _v867.array:
              length = len(val8.array)
              buff.write(_struct_I.pack(length))
              for val9 in val8.array:
                _x = val9.value
                buff.write(_get_struct_b().pack(_x))
          _x = val4.lower_triangular_correlation_matrices_is_present
          buff.write(_get_struct_B().pack(_x))
          _v868 = val4.object_dimension_z
          _v869 = _v868.value
          _x = _v869.value
          buff.write(_get_struct_H().pack(_x))
          _v870 = _v868.confidence
          _x = _v870.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_z_is_present
          buff.write(_get_struct_B().pack(_x))
          _v871 = val4.object_dimension_y
          _v872 = _v871.value
          _x = _v872.value
          buff.write(_get_struct_H().pack(_x))
          _v873 = _v871.confidence
          _x = _v873.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_y_is_present
          buff.write(_get_struct_B().pack(_x))
          _v874 = val4.object_dimension_x
          _v875 = _v874.value
          _x = _v875.value
          buff.write(_get_struct_H().pack(_x))
          _v876 = _v874.confidence
          _x = _v876.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_dimension_x_is_present
          buff.write(_get_struct_B().pack(_x))
          _v877 = val4.object_age
          _x = _v877.value
          buff.write(_get_struct_h().pack(_x))
          _x = val4.object_age_is_present
          buff.write(_get_struct_B().pack(_x))
          _v878 = val4.object_perception_quality
          _x = _v878.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.object_perception_quality_is_present
          buff.write(_get_struct_B().pack(_x))
          _v879 = val4.sensor_id_list
          length = len(_v879.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v879.array:
            _x = val6.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v880 = val4.classification
          length = len(_v880.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v880.array:
            _v881 = val6.object_class
            _x = _v881.choice
            buff.write(_get_struct_B().pack(_x))
            _v882 = _v881.vehicle_sub_class
            _x = _v882.value
            buff.write(_get_struct_B().pack(_x))
            _v883 = _v881.vru_sub_class
            _x = _v883.choice
            buff.write(_get_struct_B().pack(_x))
            _v884 = _v883.pedestrian
            _x = _v884.value
            buff.write(_get_struct_B().pack(_x))
            _v885 = _v883.bicyclist_and_light_vru_vehicle
            _x = _v885.value
            buff.write(_get_struct_B().pack(_x))
            _v886 = _v883.motorcyclist
            _x = _v886.value
            buff.write(_get_struct_B().pack(_x))
            _v887 = _v883.animal
            _x = _v887.value
            buff.write(_get_struct_B().pack(_x))
            _v888 = _v881.group_sub_class
            _v889 = _v888.cluster_id
            _x = _v889.value
            buff.write(_get_struct_B().pack(_x))
            _x = _v888.cluster_id_is_present
            buff.write(_get_struct_B().pack(_x))
            _v890 = _v888.cluster_bounding_box_shape
            _x = _v890.choice
            buff.write(_get_struct_B().pack(_x))
            _v891 = _v890.rectangular
            _v892 = _v891.center_point
            _v893 = _v892.x_coordinate
            _x = _v893.value
            buff.write(_get_struct_h().pack(_x))
            _v894 = _v892.y_coordinate
            _x = _v894.value
            buff.write(_get_struct_h().pack(_x))
            _v895 = _v892.z_coordinate
            _x = _v895.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v892.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v891.center_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v896 = _v891.semi_length
            _x = _v896.value
            buff.write(_get_struct_H().pack(_x))
            _v897 = _v891.semi_breadth
            _x = _v897.value
            buff.write(_get_struct_H().pack(_x))
            _v898 = _v891.orientation
            _x = _v898.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v891.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v899 = _v891.height
            _x = _v899.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v891.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v900 = _v890.circular
            _v901 = _v900.shape_reference_point
            _v902 = _v901.x_coordinate
            _x = _v902.value
            buff.write(_get_struct_h().pack(_x))
            _v903 = _v901.y_coordinate
            _x = _v903.value
            buff.write(_get_struct_h().pack(_x))
            _v904 = _v901.z_coordinate
            _x = _v904.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v901.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v900.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v905 = _v900.radius
            _x = _v905.value
            buff.write(_get_struct_H().pack(_x))
            _v906 = _v900.height
            _x = _v906.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v900.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v907 = _v890.polygonal
            _v908 = _v907.shape_reference_point
            _v909 = _v908.x_coordinate
            _x = _v909.value
            buff.write(_get_struct_h().pack(_x))
            _v910 = _v908.y_coordinate
            _x = _v910.value
            buff.write(_get_struct_h().pack(_x))
            _v911 = _v908.z_coordinate
            _x = _v911.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v908.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v907.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v912 = _v907.polygon
            length = len(_v912.array)
            buff.write(_struct_I.pack(length))
            for val12 in _v912.array:
              _v913 = val12.x_coordinate
              _x = _v913.value
              buff.write(_get_struct_h().pack(_x))
              _v914 = val12.y_coordinate
              _x = _v914.value
              buff.write(_get_struct_h().pack(_x))
              _v915 = val12.z_coordinate
              _x = _v915.value
              buff.write(_get_struct_h().pack(_x))
              _x = val12.z_coordinate_is_present
              buff.write(_get_struct_B().pack(_x))
            _v916 = _v907.height
            _x = _v916.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v907.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v917 = _v890.elliptical
            _v918 = _v917.shape_reference_point
            _v919 = _v918.x_coordinate
            _x = _v919.value
            buff.write(_get_struct_h().pack(_x))
            _v920 = _v918.y_coordinate
            _x = _v920.value
            buff.write(_get_struct_h().pack(_x))
            _v921 = _v918.z_coordinate
            _x = _v921.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v918.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v917.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v922 = _v917.semi_major_axis_length
            _x = _v922.value
            buff.write(_get_struct_H().pack(_x))
            _v923 = _v917.semi_minor_axis_length
            _x = _v923.value
            buff.write(_get_struct_H().pack(_x))
            _v924 = _v917.orientation
            _x = _v924.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v917.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v925 = _v917.height
            _x = _v925.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v917.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v926 = _v890.radial
            _v927 = _v926.shape_reference_point
            _v928 = _v927.x_coordinate
            _x = _v928.value
            buff.write(_get_struct_h().pack(_x))
            _v929 = _v927.y_coordinate
            _x = _v929.value
            buff.write(_get_struct_h().pack(_x))
            _v930 = _v927.z_coordinate
            _x = _v930.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v927.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v926.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v931 = _v926.range
            _x = _v931.value
            buff.write(_get_struct_H().pack(_x))
            _v932 = _v926.stationary_horizontal_opening_angle_start
            _x = _v932.value
            buff.write(_get_struct_H().pack(_x))
            _v933 = _v926.stationary_horizontal_opening_angle_end
            _x = _v933.value
            buff.write(_get_struct_H().pack(_x))
            _v934 = _v926.vertical_opening_angle_start
            _x = _v934.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v926.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v935 = _v926.vertical_opening_angle_end
            _x = _v935.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v926.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
            _v936 = _v890.radial_shapes
            _v937 = _v936.ref_point_id
            _x = _v937.value
            buff.write(_get_struct_B().pack(_x))
            _v938 = _v936.x_coordinate
            _x = _v938.value
            buff.write(_get_struct_h().pack(_x))
            _v939 = _v936.y_coordinate
            _x = _v939.value
            buff.write(_get_struct_h().pack(_x))
            _v940 = _v936.z_coordinate
            _x = _v940.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v936.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _v941 = _v936.radial_shapes_list
            length = len(_v941.array)
            buff.write(_struct_I.pack(length))
            for val12 in _v941.array:
              _v942 = val12.range
              _x = _v942.value
              buff.write(_get_struct_H().pack(_x))
              _v943 = val12.horizontal_opening_angle_start
              _x = _v943.value
              buff.write(_get_struct_H().pack(_x))
              _v944 = val12.horizontal_opening_angle_end
              _x = _v944.value
              buff.write(_get_struct_H().pack(_x))
              _v945 = val12.vertical_opening_angle_start
              _x = _v945.value
              buff.write(_get_struct_H().pack(_x))
              _x = val12.vertical_opening_angle_start_is_present
              buff.write(_get_struct_B().pack(_x))
              _v946 = val12.vertical_opening_angle_end
              _x = _v946.value
              buff.write(_get_struct_H().pack(_x))
              _x = val12.vertical_opening_angle_end_is_present
              buff.write(_get_struct_B().pack(_x))
            _x = _v888.cluster_bounding_box_shape_is_present
            buff.write(_get_struct_B().pack(_x))
            _v947 = _v888.cluster_cardinality_size
            _x = _v947.value
            buff.write(_get_struct_B().pack(_x))
            _v948 = _v888.cluster_profiles
            _x = _v948.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v948.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _x = _v888.cluster_profiles_is_present
            buff.write(_get_struct_B().pack(_x))
            _v949 = _v881.other_sub_class
            _x = _v949.value
            buff.write(_get_struct_B().pack(_x))
            _v950 = val6.confidence
            _x = _v950.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.classification_is_present
          buff.write(_get_struct_B().pack(_x))
          _v951 = val4.map_position
          _v952 = _v951.map_reference
          _x = _v952.choice
          buff.write(_get_struct_B().pack(_x))
          _v953 = _v952.roadsegment
          _v954 = _v953.region
          _x = _v954.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v953.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v955 = _v953.id
          _x = _v955.value
          buff.write(_get_struct_H().pack(_x))
          _v956 = _v952.intersection
          _v957 = _v956.region
          _x = _v957.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v956.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v958 = _v956.id
          _x = _v958.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v951.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v959 = _v951.lane_id
          _x = _v959.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v951.lane_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v960 = _v951.connection_id
          _x = _v960.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v951.connection_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v961 = _v951.longitudinal_lane_position
          _v962 = _v961.longitudinal_lane_position_value
          _x = _v962.value
          buff.write(_get_struct_H().pack(_x))
          _v963 = _v961.longitudinal_lane_position_confidence
          _x = _v963.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v951.longitudinal_lane_position_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val4.map_position_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.management_container is None:
        self.management_container = etsi_its_cpm_ts_msgs.msg.ManagementContainer()
      if self.cpm_containers is None:
        self.cpm_containers = etsi_its_cpm_ts_msgs.msg.ConstraintWrappedCpmContainers()
      end = 0
      _x = self
      start = end
      end += 35
      (_x.management_container.reference_time.value, _x.management_container.reference_position.latitude.value, _x.management_container.reference_position.longitude.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_minor_confidence.value, _x.management_container.reference_position.position_confidence_ellipse.semi_major_orientation.value, _x.management_container.reference_position.altitude.altitude_value.value, _x.management_container.reference_position.altitude.altitude_confidence.value, _x.management_container.segmentation_info.total_msg_no.value, _x.management_container.segmentation_info.this_msg_no.value, _x.management_container.segmentation_info_is_present, _x.management_container.message_rate_range.message_rate_min.mantissa, _x.management_container.message_rate_range.message_rate_min.exponent, _x.management_container.message_rate_range.message_rate_max.mantissa, _x.management_container.message_rate_range.message_rate_max.exponent, _x.management_container.message_rate_range_is_present,) = _get_struct_Q2i3Hi5BbBbB().unpack(str[start:end])
      self.management_container.segmentation_info_is_present = bool(self.management_container.segmentation_info_is_present)
      self.management_container.message_rate_range_is_present = bool(self.management_container.message_rate_range_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cpm_containers.value.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.WrappedCpmContainer()
        _v964 = val1.container_id
        start = end
        end += 1
        (_v964.value,) = _get_struct_B().unpack(str[start:end])
        _v965 = val1.container_data_originating_vehicle_container
        _v966 = _v965.orientation_angle
        _v967 = _v966.value
        start = end
        end += 2
        (_v967.value,) = _get_struct_H().unpack(str[start:end])
        _v968 = _v966.confidence
        start = end
        end += 1
        (_v968.value,) = _get_struct_B().unpack(str[start:end])
        _v969 = _v965.pitch_angle
        _v970 = _v969.value
        start = end
        end += 2
        (_v970.value,) = _get_struct_H().unpack(str[start:end])
        _v971 = _v969.confidence
        start = end
        end += 1
        (_v971.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v965.pitch_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v965.pitch_angle_is_present = bool(_v965.pitch_angle_is_present)
        _v972 = _v965.roll_angle
        _v973 = _v972.value
        start = end
        end += 2
        (_v973.value,) = _get_struct_H().unpack(str[start:end])
        _v974 = _v972.confidence
        start = end
        end += 1
        (_v974.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v965.roll_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v965.roll_angle_is_present = bool(_v965.roll_angle_is_present)
        _v975 = _v965.trailer_data_set
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v975.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.TrailerData()
          _v976 = val4.ref_point_id
          start = end
          end += 1
          (_v976.value,) = _get_struct_B().unpack(str[start:end])
          _v977 = val4.hitch_point_offset
          start = end
          end += 1
          (_v977.value,) = _get_struct_B().unpack(str[start:end])
          _v978 = val4.front_overhang
          start = end
          end += 1
          (_v978.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.front_overhang_is_present = bool(val4.front_overhang_is_present)
          _v979 = val4.rear_overhang
          start = end
          end += 1
          (_v979.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.rear_overhang_is_present = bool(val4.rear_overhang_is_present)
          _v980 = val4.trailer_width
          start = end
          end += 1
          (_v980.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.trailer_width_is_present = bool(val4.trailer_width_is_present)
          _v981 = val4.hitch_angle
          _v982 = _v981.value
          start = end
          end += 2
          (_v982.value,) = _get_struct_H().unpack(str[start:end])
          _v983 = _v981.confidence
          start = end
          end += 1
          (_v983.value,) = _get_struct_B().unpack(str[start:end])
          _v975.array.append(val4)
        start = end
        end += 1
        (_v965.trailer_data_set_is_present,) = _get_struct_B().unpack(str[start:end])
        _v965.trailer_data_set_is_present = bool(_v965.trailer_data_set_is_present)
        _v984 = val1.container_data_originating_rsu_container
        _v985 = _v984.map_reference
        start = end
        end += 1
        (_v985.choice,) = _get_struct_B().unpack(str[start:end])
        _v986 = _v985.roadsegment
        _v987 = _v986.region
        start = end
        end += 2
        (_v987.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v986.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v986.region_is_present = bool(_v986.region_is_present)
        _v988 = _v986.id
        start = end
        end += 2
        (_v988.value,) = _get_struct_H().unpack(str[start:end])
        _v989 = _v985.intersection
        _v990 = _v989.region
        start = end
        end += 2
        (_v990.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v989.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v989.region_is_present = bool(_v989.region_is_present)
        _v991 = _v989.id
        start = end
        end += 2
        (_v991.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v984.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v984.map_reference_is_present = bool(_v984.map_reference_is_present)
        _v992 = val1.container_data_sensor_information_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v992.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
          _v993 = val3.sensor_id
          start = end
          end += 1
          (_v993.value,) = _get_struct_B().unpack(str[start:end])
          _v994 = val3.sensor_type
          start = end
          end += 1
          (_v994.value,) = _get_struct_B().unpack(str[start:end])
          _v995 = val3.perception_region_shape
          start = end
          end += 1
          (_v995.choice,) = _get_struct_B().unpack(str[start:end])
          _v996 = _v995.rectangular
          _v997 = _v996.center_point
          _v998 = _v997.x_coordinate
          start = end
          end += 2
          (_v998.value,) = _get_struct_h().unpack(str[start:end])
          _v999 = _v997.y_coordinate
          start = end
          end += 2
          (_v999.value,) = _get_struct_h().unpack(str[start:end])
          _v1000 = _v997.z_coordinate
          start = end
          end += 2
          (_v1000.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v997.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v997.z_coordinate_is_present = bool(_v997.z_coordinate_is_present)
          start = end
          end += 1
          (_v996.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v996.center_point_is_present = bool(_v996.center_point_is_present)
          _v1001 = _v996.semi_length
          start = end
          end += 2
          (_v1001.value,) = _get_struct_H().unpack(str[start:end])
          _v1002 = _v996.semi_breadth
          start = end
          end += 2
          (_v1002.value,) = _get_struct_H().unpack(str[start:end])
          _v1003 = _v996.orientation
          start = end
          end += 2
          (_v1003.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v996.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v996.orientation_is_present = bool(_v996.orientation_is_present)
          _v1004 = _v996.height
          start = end
          end += 2
          (_v1004.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v996.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v996.height_is_present = bool(_v996.height_is_present)
          _v1005 = _v995.circular
          _v1006 = _v1005.shape_reference_point
          _v1007 = _v1006.x_coordinate
          start = end
          end += 2
          (_v1007.value,) = _get_struct_h().unpack(str[start:end])
          _v1008 = _v1006.y_coordinate
          start = end
          end += 2
          (_v1008.value,) = _get_struct_h().unpack(str[start:end])
          _v1009 = _v1006.z_coordinate
          start = end
          end += 2
          (_v1009.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1006.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1006.z_coordinate_is_present = bool(_v1006.z_coordinate_is_present)
          start = end
          end += 1
          (_v1005.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1005.shape_reference_point_is_present = bool(_v1005.shape_reference_point_is_present)
          _v1010 = _v1005.radius
          start = end
          end += 2
          (_v1010.value,) = _get_struct_H().unpack(str[start:end])
          _v1011 = _v1005.height
          start = end
          end += 2
          (_v1011.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1005.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1005.height_is_present = bool(_v1005.height_is_present)
          _v1012 = _v995.polygonal
          _v1013 = _v1012.shape_reference_point
          _v1014 = _v1013.x_coordinate
          start = end
          end += 2
          (_v1014.value,) = _get_struct_h().unpack(str[start:end])
          _v1015 = _v1013.y_coordinate
          start = end
          end += 2
          (_v1015.value,) = _get_struct_h().unpack(str[start:end])
          _v1016 = _v1013.z_coordinate
          start = end
          end += 2
          (_v1016.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1013.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1013.z_coordinate_is_present = bool(_v1013.z_coordinate_is_present)
          start = end
          end += 1
          (_v1012.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1012.shape_reference_point_is_present = bool(_v1012.shape_reference_point_is_present)
          _v1017 = _v1012.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1017.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v1018 = val7.x_coordinate
            start = end
            end += 2
            (_v1018.value,) = _get_struct_h().unpack(str[start:end])
            _v1019 = val7.y_coordinate
            start = end
            end += 2
            (_v1019.value,) = _get_struct_h().unpack(str[start:end])
            _v1020 = val7.z_coordinate
            start = end
            end += 2
            (_v1020.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
            _v1017.array.append(val7)
          _v1021 = _v1012.height
          start = end
          end += 2
          (_v1021.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1012.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1012.height_is_present = bool(_v1012.height_is_present)
          _v1022 = _v995.elliptical
          _v1023 = _v1022.shape_reference_point
          _v1024 = _v1023.x_coordinate
          start = end
          end += 2
          (_v1024.value,) = _get_struct_h().unpack(str[start:end])
          _v1025 = _v1023.y_coordinate
          start = end
          end += 2
          (_v1025.value,) = _get_struct_h().unpack(str[start:end])
          _v1026 = _v1023.z_coordinate
          start = end
          end += 2
          (_v1026.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1023.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1023.z_coordinate_is_present = bool(_v1023.z_coordinate_is_present)
          start = end
          end += 1
          (_v1022.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1022.shape_reference_point_is_present = bool(_v1022.shape_reference_point_is_present)
          _v1027 = _v1022.semi_major_axis_length
          start = end
          end += 2
          (_v1027.value,) = _get_struct_H().unpack(str[start:end])
          _v1028 = _v1022.semi_minor_axis_length
          start = end
          end += 2
          (_v1028.value,) = _get_struct_H().unpack(str[start:end])
          _v1029 = _v1022.orientation
          start = end
          end += 2
          (_v1029.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1022.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1022.orientation_is_present = bool(_v1022.orientation_is_present)
          _v1030 = _v1022.height
          start = end
          end += 2
          (_v1030.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1022.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1022.height_is_present = bool(_v1022.height_is_present)
          _v1031 = _v995.radial
          _v1032 = _v1031.shape_reference_point
          _v1033 = _v1032.x_coordinate
          start = end
          end += 2
          (_v1033.value,) = _get_struct_h().unpack(str[start:end])
          _v1034 = _v1032.y_coordinate
          start = end
          end += 2
          (_v1034.value,) = _get_struct_h().unpack(str[start:end])
          _v1035 = _v1032.z_coordinate
          start = end
          end += 2
          (_v1035.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1032.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1032.z_coordinate_is_present = bool(_v1032.z_coordinate_is_present)
          start = end
          end += 1
          (_v1031.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1031.shape_reference_point_is_present = bool(_v1031.shape_reference_point_is_present)
          _v1036 = _v1031.range
          start = end
          end += 2
          (_v1036.value,) = _get_struct_H().unpack(str[start:end])
          _v1037 = _v1031.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v1037.value,) = _get_struct_H().unpack(str[start:end])
          _v1038 = _v1031.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v1038.value,) = _get_struct_H().unpack(str[start:end])
          _v1039 = _v1031.vertical_opening_angle_start
          start = end
          end += 2
          (_v1039.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1031.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1031.vertical_opening_angle_start_is_present = bool(_v1031.vertical_opening_angle_start_is_present)
          _v1040 = _v1031.vertical_opening_angle_end
          start = end
          end += 2
          (_v1040.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1031.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1031.vertical_opening_angle_end_is_present = bool(_v1031.vertical_opening_angle_end_is_present)
          _v1041 = _v995.radial_shapes
          _v1042 = _v1041.ref_point_id
          start = end
          end += 1
          (_v1042.value,) = _get_struct_B().unpack(str[start:end])
          _v1043 = _v1041.x_coordinate
          start = end
          end += 2
          (_v1043.value,) = _get_struct_h().unpack(str[start:end])
          _v1044 = _v1041.y_coordinate
          start = end
          end += 2
          (_v1044.value,) = _get_struct_h().unpack(str[start:end])
          _v1045 = _v1041.z_coordinate
          start = end
          end += 2
          (_v1045.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1041.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1041.z_coordinate_is_present = bool(_v1041.z_coordinate_is_present)
          _v1046 = _v1041.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1046.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v1047 = val7.range
            start = end
            end += 2
            (_v1047.value,) = _get_struct_H().unpack(str[start:end])
            _v1048 = val7.horizontal_opening_angle_start
            start = end
            end += 2
            (_v1048.value,) = _get_struct_H().unpack(str[start:end])
            _v1049 = val7.horizontal_opening_angle_end
            start = end
            end += 2
            (_v1049.value,) = _get_struct_H().unpack(str[start:end])
            _v1050 = val7.vertical_opening_angle_start
            start = end
            end += 2
            (_v1050.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
            _v1051 = val7.vertical_opening_angle_end
            start = end
            end += 2
            (_v1051.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
            _v1046.array.append(val7)
          start = end
          end += 1
          (val3.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.perception_region_shape_is_present = bool(val3.perception_region_shape_is_present)
          _v1052 = val3.perception_region_confidence
          start = end
          end += 1
          (_v1052.value,) = _get_struct_B().unpack(str[start:end])
          _x = val3
          start = end
          end += 2
          (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
          val3.perception_region_confidence_is_present = bool(val3.perception_region_confidence_is_present)
          val3.shadowing_applies = bool(val3.shadowing_applies)
          _v992.array.append(val3)
        _v1053 = val1.container_data_perception_region_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1053.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
          _v1054 = val3.measurement_delta_time
          start = end
          end += 2
          (_v1054.value,) = _get_struct_h().unpack(str[start:end])
          _v1055 = val3.perception_region_confidence
          start = end
          end += 1
          (_v1055.value,) = _get_struct_B().unpack(str[start:end])
          _v1056 = val3.perception_region_shape
          start = end
          end += 1
          (_v1056.choice,) = _get_struct_B().unpack(str[start:end])
          _v1057 = _v1056.rectangular
          _v1058 = _v1057.center_point
          _v1059 = _v1058.x_coordinate
          start = end
          end += 2
          (_v1059.value,) = _get_struct_h().unpack(str[start:end])
          _v1060 = _v1058.y_coordinate
          start = end
          end += 2
          (_v1060.value,) = _get_struct_h().unpack(str[start:end])
          _v1061 = _v1058.z_coordinate
          start = end
          end += 2
          (_v1061.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1058.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1058.z_coordinate_is_present = bool(_v1058.z_coordinate_is_present)
          start = end
          end += 1
          (_v1057.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1057.center_point_is_present = bool(_v1057.center_point_is_present)
          _v1062 = _v1057.semi_length
          start = end
          end += 2
          (_v1062.value,) = _get_struct_H().unpack(str[start:end])
          _v1063 = _v1057.semi_breadth
          start = end
          end += 2
          (_v1063.value,) = _get_struct_H().unpack(str[start:end])
          _v1064 = _v1057.orientation
          start = end
          end += 2
          (_v1064.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1057.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1057.orientation_is_present = bool(_v1057.orientation_is_present)
          _v1065 = _v1057.height
          start = end
          end += 2
          (_v1065.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1057.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1057.height_is_present = bool(_v1057.height_is_present)
          _v1066 = _v1056.circular
          _v1067 = _v1066.shape_reference_point
          _v1068 = _v1067.x_coordinate
          start = end
          end += 2
          (_v1068.value,) = _get_struct_h().unpack(str[start:end])
          _v1069 = _v1067.y_coordinate
          start = end
          end += 2
          (_v1069.value,) = _get_struct_h().unpack(str[start:end])
          _v1070 = _v1067.z_coordinate
          start = end
          end += 2
          (_v1070.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1067.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1067.z_coordinate_is_present = bool(_v1067.z_coordinate_is_present)
          start = end
          end += 1
          (_v1066.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1066.shape_reference_point_is_present = bool(_v1066.shape_reference_point_is_present)
          _v1071 = _v1066.radius
          start = end
          end += 2
          (_v1071.value,) = _get_struct_H().unpack(str[start:end])
          _v1072 = _v1066.height
          start = end
          end += 2
          (_v1072.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1066.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1066.height_is_present = bool(_v1066.height_is_present)
          _v1073 = _v1056.polygonal
          _v1074 = _v1073.shape_reference_point
          _v1075 = _v1074.x_coordinate
          start = end
          end += 2
          (_v1075.value,) = _get_struct_h().unpack(str[start:end])
          _v1076 = _v1074.y_coordinate
          start = end
          end += 2
          (_v1076.value,) = _get_struct_h().unpack(str[start:end])
          _v1077 = _v1074.z_coordinate
          start = end
          end += 2
          (_v1077.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1074.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1074.z_coordinate_is_present = bool(_v1074.z_coordinate_is_present)
          start = end
          end += 1
          (_v1073.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1073.shape_reference_point_is_present = bool(_v1073.shape_reference_point_is_present)
          _v1078 = _v1073.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1078.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v1079 = val7.x_coordinate
            start = end
            end += 2
            (_v1079.value,) = _get_struct_h().unpack(str[start:end])
            _v1080 = val7.y_coordinate
            start = end
            end += 2
            (_v1080.value,) = _get_struct_h().unpack(str[start:end])
            _v1081 = val7.z_coordinate
            start = end
            end += 2
            (_v1081.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
            _v1078.array.append(val7)
          _v1082 = _v1073.height
          start = end
          end += 2
          (_v1082.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1073.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1073.height_is_present = bool(_v1073.height_is_present)
          _v1083 = _v1056.elliptical
          _v1084 = _v1083.shape_reference_point
          _v1085 = _v1084.x_coordinate
          start = end
          end += 2
          (_v1085.value,) = _get_struct_h().unpack(str[start:end])
          _v1086 = _v1084.y_coordinate
          start = end
          end += 2
          (_v1086.value,) = _get_struct_h().unpack(str[start:end])
          _v1087 = _v1084.z_coordinate
          start = end
          end += 2
          (_v1087.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1084.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1084.z_coordinate_is_present = bool(_v1084.z_coordinate_is_present)
          start = end
          end += 1
          (_v1083.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1083.shape_reference_point_is_present = bool(_v1083.shape_reference_point_is_present)
          _v1088 = _v1083.semi_major_axis_length
          start = end
          end += 2
          (_v1088.value,) = _get_struct_H().unpack(str[start:end])
          _v1089 = _v1083.semi_minor_axis_length
          start = end
          end += 2
          (_v1089.value,) = _get_struct_H().unpack(str[start:end])
          _v1090 = _v1083.orientation
          start = end
          end += 2
          (_v1090.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1083.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1083.orientation_is_present = bool(_v1083.orientation_is_present)
          _v1091 = _v1083.height
          start = end
          end += 2
          (_v1091.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1083.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1083.height_is_present = bool(_v1083.height_is_present)
          _v1092 = _v1056.radial
          _v1093 = _v1092.shape_reference_point
          _v1094 = _v1093.x_coordinate
          start = end
          end += 2
          (_v1094.value,) = _get_struct_h().unpack(str[start:end])
          _v1095 = _v1093.y_coordinate
          start = end
          end += 2
          (_v1095.value,) = _get_struct_h().unpack(str[start:end])
          _v1096 = _v1093.z_coordinate
          start = end
          end += 2
          (_v1096.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1093.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1093.z_coordinate_is_present = bool(_v1093.z_coordinate_is_present)
          start = end
          end += 1
          (_v1092.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1092.shape_reference_point_is_present = bool(_v1092.shape_reference_point_is_present)
          _v1097 = _v1092.range
          start = end
          end += 2
          (_v1097.value,) = _get_struct_H().unpack(str[start:end])
          _v1098 = _v1092.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v1098.value,) = _get_struct_H().unpack(str[start:end])
          _v1099 = _v1092.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v1099.value,) = _get_struct_H().unpack(str[start:end])
          _v1100 = _v1092.vertical_opening_angle_start
          start = end
          end += 2
          (_v1100.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1092.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1092.vertical_opening_angle_start_is_present = bool(_v1092.vertical_opening_angle_start_is_present)
          _v1101 = _v1092.vertical_opening_angle_end
          start = end
          end += 2
          (_v1101.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1092.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1092.vertical_opening_angle_end_is_present = bool(_v1092.vertical_opening_angle_end_is_present)
          _v1102 = _v1056.radial_shapes
          _v1103 = _v1102.ref_point_id
          start = end
          end += 1
          (_v1103.value,) = _get_struct_B().unpack(str[start:end])
          _v1104 = _v1102.x_coordinate
          start = end
          end += 2
          (_v1104.value,) = _get_struct_h().unpack(str[start:end])
          _v1105 = _v1102.y_coordinate
          start = end
          end += 2
          (_v1105.value,) = _get_struct_h().unpack(str[start:end])
          _v1106 = _v1102.z_coordinate
          start = end
          end += 2
          (_v1106.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1102.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1102.z_coordinate_is_present = bool(_v1102.z_coordinate_is_present)
          _v1107 = _v1102.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1107.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v1108 = val7.range
            start = end
            end += 2
            (_v1108.value,) = _get_struct_H().unpack(str[start:end])
            _v1109 = val7.horizontal_opening_angle_start
            start = end
            end += 2
            (_v1109.value,) = _get_struct_H().unpack(str[start:end])
            _v1110 = val7.horizontal_opening_angle_end
            start = end
            end += 2
            (_v1110.value,) = _get_struct_H().unpack(str[start:end])
            _v1111 = val7.vertical_opening_angle_start
            start = end
            end += 2
            (_v1111.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
            _v1112 = val7.vertical_opening_angle_end
            start = end
            end += 2
            (_v1112.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
            _v1107.array.append(val7)
          start = end
          end += 1
          (val3.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
          val3.shadowing_applies = bool(val3.shadowing_applies)
          _v1113 = val3.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1113.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v1113.array.append(val5)
          start = end
          end += 1
          (val3.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.sensor_id_list_is_present = bool(val3.sensor_id_list_is_present)
          _v1114 = val3.number_of_perceived_objects
          start = end
          end += 1
          (_v1114.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val3.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.number_of_perceived_objects_is_present = bool(val3.number_of_perceived_objects_is_present)
          _v1115 = val3.perceived_object_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1115.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
            start = end
            end += 2
            (val5.value,) = _get_struct_H().unpack(str[start:end])
            _v1115.array.append(val5)
          start = end
          end += 1
          (val3.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.perceived_object_ids_is_present = bool(val3.perceived_object_ids_is_present)
          _v1053.array.append(val3)
        _v1116 = val1.container_data_perceived_object_container
        _v1117 = _v1116.number_of_perceived_objects
        start = end
        end += 1
        (_v1117.value,) = _get_struct_B().unpack(str[start:end])
        _v1118 = _v1116.perceived_objects
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1118.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
          _v1119 = val4.object_id
          start = end
          end += 2
          (_v1119.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_id_is_present = bool(val4.object_id_is_present)
          _v1120 = val4.measurement_delta_time
          start = end
          end += 2
          (_v1120.value,) = _get_struct_h().unpack(str[start:end])
          _v1121 = val4.position
          _v1122 = _v1121.x_coordinate
          _v1123 = _v1122.value
          start = end
          end += 4
          (_v1123.value,) = _get_struct_i().unpack(str[start:end])
          _v1124 = _v1122.confidence
          start = end
          end += 2
          (_v1124.value,) = _get_struct_H().unpack(str[start:end])
          _v1125 = _v1121.y_coordinate
          _v1126 = _v1125.value
          start = end
          end += 4
          (_v1126.value,) = _get_struct_i().unpack(str[start:end])
          _v1127 = _v1125.confidence
          start = end
          end += 2
          (_v1127.value,) = _get_struct_H().unpack(str[start:end])
          _v1128 = _v1121.z_coordinate
          _v1129 = _v1128.value
          start = end
          end += 4
          (_v1129.value,) = _get_struct_i().unpack(str[start:end])
          _v1130 = _v1128.confidence
          start = end
          end += 2
          (_v1130.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1121.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1121.z_coordinate_is_present = bool(_v1121.z_coordinate_is_present)
          _v1131 = val4.velocity
          start = end
          end += 1
          (_v1131.choice,) = _get_struct_B().unpack(str[start:end])
          _v1132 = _v1131.polar_velocity
          _v1133 = _v1132.velocity_magnitude
          _v1134 = _v1133.speed_value
          start = end
          end += 2
          (_v1134.value,) = _get_struct_H().unpack(str[start:end])
          _v1135 = _v1133.speed_confidence
          start = end
          end += 1
          (_v1135.value,) = _get_struct_B().unpack(str[start:end])
          _v1136 = _v1132.velocity_direction
          _v1137 = _v1136.value
          start = end
          end += 2
          (_v1137.value,) = _get_struct_H().unpack(str[start:end])
          _v1138 = _v1136.confidence
          start = end
          end += 1
          (_v1138.value,) = _get_struct_B().unpack(str[start:end])
          _v1139 = _v1132.z_velocity
          _v1140 = _v1139.value
          start = end
          end += 2
          (_v1140.value,) = _get_struct_h().unpack(str[start:end])
          _v1141 = _v1139.confidence
          start = end
          end += 1
          (_v1141.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1132.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1132.z_velocity_is_present = bool(_v1132.z_velocity_is_present)
          _v1142 = _v1131.cartesian_velocity
          _v1143 = _v1142.x_velocity
          _v1144 = _v1143.value
          start = end
          end += 2
          (_v1144.value,) = _get_struct_h().unpack(str[start:end])
          _v1145 = _v1143.confidence
          start = end
          end += 1
          (_v1145.value,) = _get_struct_B().unpack(str[start:end])
          _v1146 = _v1142.y_velocity
          _v1147 = _v1146.value
          start = end
          end += 2
          (_v1147.value,) = _get_struct_h().unpack(str[start:end])
          _v1148 = _v1146.confidence
          start = end
          end += 1
          (_v1148.value,) = _get_struct_B().unpack(str[start:end])
          _v1149 = _v1142.z_velocity
          _v1150 = _v1149.value
          start = end
          end += 2
          (_v1150.value,) = _get_struct_h().unpack(str[start:end])
          _v1151 = _v1149.confidence
          start = end
          end += 1
          (_v1151.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1142.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1142.z_velocity_is_present = bool(_v1142.z_velocity_is_present)
          start = end
          end += 1
          (val4.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.velocity_is_present = bool(val4.velocity_is_present)
          _v1152 = val4.acceleration
          start = end
          end += 1
          (_v1152.choice,) = _get_struct_B().unpack(str[start:end])
          _v1153 = _v1152.polar_acceleration
          _v1154 = _v1153.acceleration_magnitude
          _v1155 = _v1154.acceleration_magnitude_value
          start = end
          end += 1
          (_v1155.value,) = _get_struct_B().unpack(str[start:end])
          _v1156 = _v1154.acceleration_confidence
          start = end
          end += 1
          (_v1156.value,) = _get_struct_B().unpack(str[start:end])
          _v1157 = _v1153.acceleration_direction
          _v1158 = _v1157.value
          start = end
          end += 2
          (_v1158.value,) = _get_struct_H().unpack(str[start:end])
          _v1159 = _v1157.confidence
          start = end
          end += 1
          (_v1159.value,) = _get_struct_B().unpack(str[start:end])
          _v1160 = _v1153.z_acceleration
          _v1161 = _v1160.value
          start = end
          end += 2
          (_v1161.value,) = _get_struct_h().unpack(str[start:end])
          _v1162 = _v1160.confidence
          start = end
          end += 1
          (_v1162.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1153.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1153.z_acceleration_is_present = bool(_v1153.z_acceleration_is_present)
          _v1163 = _v1152.cartesian_acceleration
          _v1164 = _v1163.x_acceleration
          _v1165 = _v1164.value
          start = end
          end += 2
          (_v1165.value,) = _get_struct_h().unpack(str[start:end])
          _v1166 = _v1164.confidence
          start = end
          end += 1
          (_v1166.value,) = _get_struct_B().unpack(str[start:end])
          _v1167 = _v1163.y_acceleration
          _v1168 = _v1167.value
          start = end
          end += 2
          (_v1168.value,) = _get_struct_h().unpack(str[start:end])
          _v1169 = _v1167.confidence
          start = end
          end += 1
          (_v1169.value,) = _get_struct_B().unpack(str[start:end])
          _v1170 = _v1163.z_acceleration
          _v1171 = _v1170.value
          start = end
          end += 2
          (_v1171.value,) = _get_struct_h().unpack(str[start:end])
          _v1172 = _v1170.confidence
          start = end
          end += 1
          (_v1172.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1163.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1163.z_acceleration_is_present = bool(_v1163.z_acceleration_is_present)
          start = end
          end += 1
          (val4.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.acceleration_is_present = bool(val4.acceleration_is_present)
          _v1173 = val4.angles
          _v1174 = _v1173.z_angle
          _v1175 = _v1174.value
          start = end
          end += 2
          (_v1175.value,) = _get_struct_H().unpack(str[start:end])
          _v1176 = _v1174.confidence
          start = end
          end += 1
          (_v1176.value,) = _get_struct_B().unpack(str[start:end])
          _v1177 = _v1173.y_angle
          _v1178 = _v1177.value
          start = end
          end += 2
          (_v1178.value,) = _get_struct_H().unpack(str[start:end])
          _v1179 = _v1177.confidence
          start = end
          end += 1
          (_v1179.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1173.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1173.y_angle_is_present = bool(_v1173.y_angle_is_present)
          _v1180 = _v1173.x_angle
          _v1181 = _v1180.value
          start = end
          end += 2
          (_v1181.value,) = _get_struct_H().unpack(str[start:end])
          _v1182 = _v1180.confidence
          start = end
          end += 1
          (_v1182.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1173.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1173.x_angle_is_present = bool(_v1173.x_angle_is_present)
          start = end
          end += 1
          (val4.angles_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.angles_is_present = bool(val4.angles_is_present)
          _v1183 = val4.z_angular_velocity
          _v1184 = _v1183.value
          start = end
          end += 2
          (_v1184.value,) = _get_struct_h().unpack(str[start:end])
          _v1185 = _v1183.confidence
          start = end
          end += 1
          (_v1185.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.z_angular_velocity_is_present = bool(val4.z_angular_velocity_is_present)
          _v1186 = val4.lower_triangular_correlation_matrices
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1186.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
            _v1187 = val6.components_included_inthe_matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v1187.value = str[start:end]
            start = end
            end += 1
            (_v1187.bits_unused,) = _get_struct_B().unpack(str[start:end])
            _v1188 = val6.matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1188.array = []
            for i in range(0, length):
              val8 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              val8.array = []
              for i in range(0, length):
                val9 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
                start = end
                end += 1
                (val9.value,) = _get_struct_b().unpack(str[start:end])
                val8.array.append(val9)
              _v1188.array.append(val8)
            _v1186.array.append(val6)
          start = end
          end += 1
          (val4.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.lower_triangular_correlation_matrices_is_present = bool(val4.lower_triangular_correlation_matrices_is_present)
          _v1189 = val4.object_dimension_z
          _v1190 = _v1189.value
          start = end
          end += 2
          (_v1190.value,) = _get_struct_H().unpack(str[start:end])
          _v1191 = _v1189.confidence
          start = end
          end += 1
          (_v1191.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_z_is_present = bool(val4.object_dimension_z_is_present)
          _v1192 = val4.object_dimension_y
          _v1193 = _v1192.value
          start = end
          end += 2
          (_v1193.value,) = _get_struct_H().unpack(str[start:end])
          _v1194 = _v1192.confidence
          start = end
          end += 1
          (_v1194.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_y_is_present = bool(val4.object_dimension_y_is_present)
          _v1195 = val4.object_dimension_x
          _v1196 = _v1195.value
          start = end
          end += 2
          (_v1196.value,) = _get_struct_H().unpack(str[start:end])
          _v1197 = _v1195.confidence
          start = end
          end += 1
          (_v1197.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_dimension_x_is_present = bool(val4.object_dimension_x_is_present)
          _v1198 = val4.object_age
          start = end
          end += 2
          (_v1198.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_age_is_present = bool(val4.object_age_is_present)
          _v1199 = val4.object_perception_quality
          start = end
          end += 1
          (_v1199.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.object_perception_quality_is_present = bool(val4.object_perception_quality_is_present)
          _v1200 = val4.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1200.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val6.value,) = _get_struct_B().unpack(str[start:end])
            _v1200.array.append(val6)
          start = end
          end += 1
          (val4.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.sensor_id_list_is_present = bool(val4.sensor_id_list_is_present)
          _v1201 = val4.classification
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1201.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
            _v1202 = val6.object_class
            start = end
            end += 1
            (_v1202.choice,) = _get_struct_B().unpack(str[start:end])
            _v1203 = _v1202.vehicle_sub_class
            start = end
            end += 1
            (_v1203.value,) = _get_struct_B().unpack(str[start:end])
            _v1204 = _v1202.vru_sub_class
            start = end
            end += 1
            (_v1204.choice,) = _get_struct_B().unpack(str[start:end])
            _v1205 = _v1204.pedestrian
            start = end
            end += 1
            (_v1205.value,) = _get_struct_B().unpack(str[start:end])
            _v1206 = _v1204.bicyclist_and_light_vru_vehicle
            start = end
            end += 1
            (_v1206.value,) = _get_struct_B().unpack(str[start:end])
            _v1207 = _v1204.motorcyclist
            start = end
            end += 1
            (_v1207.value,) = _get_struct_B().unpack(str[start:end])
            _v1208 = _v1204.animal
            start = end
            end += 1
            (_v1208.value,) = _get_struct_B().unpack(str[start:end])
            _v1209 = _v1202.group_sub_class
            _v1210 = _v1209.cluster_id
            start = end
            end += 1
            (_v1210.value,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v1209.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1209.cluster_id_is_present = bool(_v1209.cluster_id_is_present)
            _v1211 = _v1209.cluster_bounding_box_shape
            start = end
            end += 1
            (_v1211.choice,) = _get_struct_B().unpack(str[start:end])
            _v1212 = _v1211.rectangular
            _v1213 = _v1212.center_point
            _v1214 = _v1213.x_coordinate
            start = end
            end += 2
            (_v1214.value,) = _get_struct_h().unpack(str[start:end])
            _v1215 = _v1213.y_coordinate
            start = end
            end += 2
            (_v1215.value,) = _get_struct_h().unpack(str[start:end])
            _v1216 = _v1213.z_coordinate
            start = end
            end += 2
            (_v1216.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1213.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1213.z_coordinate_is_present = bool(_v1213.z_coordinate_is_present)
            start = end
            end += 1
            (_v1212.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1212.center_point_is_present = bool(_v1212.center_point_is_present)
            _v1217 = _v1212.semi_length
            start = end
            end += 2
            (_v1217.value,) = _get_struct_H().unpack(str[start:end])
            _v1218 = _v1212.semi_breadth
            start = end
            end += 2
            (_v1218.value,) = _get_struct_H().unpack(str[start:end])
            _v1219 = _v1212.orientation
            start = end
            end += 2
            (_v1219.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1212.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1212.orientation_is_present = bool(_v1212.orientation_is_present)
            _v1220 = _v1212.height
            start = end
            end += 2
            (_v1220.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1212.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1212.height_is_present = bool(_v1212.height_is_present)
            _v1221 = _v1211.circular
            _v1222 = _v1221.shape_reference_point
            _v1223 = _v1222.x_coordinate
            start = end
            end += 2
            (_v1223.value,) = _get_struct_h().unpack(str[start:end])
            _v1224 = _v1222.y_coordinate
            start = end
            end += 2
            (_v1224.value,) = _get_struct_h().unpack(str[start:end])
            _v1225 = _v1222.z_coordinate
            start = end
            end += 2
            (_v1225.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1222.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1222.z_coordinate_is_present = bool(_v1222.z_coordinate_is_present)
            start = end
            end += 1
            (_v1221.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1221.shape_reference_point_is_present = bool(_v1221.shape_reference_point_is_present)
            _v1226 = _v1221.radius
            start = end
            end += 2
            (_v1226.value,) = _get_struct_H().unpack(str[start:end])
            _v1227 = _v1221.height
            start = end
            end += 2
            (_v1227.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1221.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1221.height_is_present = bool(_v1221.height_is_present)
            _v1228 = _v1211.polygonal
            _v1229 = _v1228.shape_reference_point
            _v1230 = _v1229.x_coordinate
            start = end
            end += 2
            (_v1230.value,) = _get_struct_h().unpack(str[start:end])
            _v1231 = _v1229.y_coordinate
            start = end
            end += 2
            (_v1231.value,) = _get_struct_h().unpack(str[start:end])
            _v1232 = _v1229.z_coordinate
            start = end
            end += 2
            (_v1232.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1229.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1229.z_coordinate_is_present = bool(_v1229.z_coordinate_is_present)
            start = end
            end += 1
            (_v1228.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1228.shape_reference_point_is_present = bool(_v1228.shape_reference_point_is_present)
            _v1233 = _v1228.polygon
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1233.array = []
            for i in range(0, length):
              val12 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
              _v1234 = val12.x_coordinate
              start = end
              end += 2
              (_v1234.value,) = _get_struct_h().unpack(str[start:end])
              _v1235 = val12.y_coordinate
              start = end
              end += 2
              (_v1235.value,) = _get_struct_h().unpack(str[start:end])
              _v1236 = val12.z_coordinate
              start = end
              end += 2
              (_v1236.value,) = _get_struct_h().unpack(str[start:end])
              start = end
              end += 1
              (val12.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.z_coordinate_is_present = bool(val12.z_coordinate_is_present)
              _v1233.array.append(val12)
            _v1237 = _v1228.height
            start = end
            end += 2
            (_v1237.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1228.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1228.height_is_present = bool(_v1228.height_is_present)
            _v1238 = _v1211.elliptical
            _v1239 = _v1238.shape_reference_point
            _v1240 = _v1239.x_coordinate
            start = end
            end += 2
            (_v1240.value,) = _get_struct_h().unpack(str[start:end])
            _v1241 = _v1239.y_coordinate
            start = end
            end += 2
            (_v1241.value,) = _get_struct_h().unpack(str[start:end])
            _v1242 = _v1239.z_coordinate
            start = end
            end += 2
            (_v1242.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1239.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1239.z_coordinate_is_present = bool(_v1239.z_coordinate_is_present)
            start = end
            end += 1
            (_v1238.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1238.shape_reference_point_is_present = bool(_v1238.shape_reference_point_is_present)
            _v1243 = _v1238.semi_major_axis_length
            start = end
            end += 2
            (_v1243.value,) = _get_struct_H().unpack(str[start:end])
            _v1244 = _v1238.semi_minor_axis_length
            start = end
            end += 2
            (_v1244.value,) = _get_struct_H().unpack(str[start:end])
            _v1245 = _v1238.orientation
            start = end
            end += 2
            (_v1245.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1238.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1238.orientation_is_present = bool(_v1238.orientation_is_present)
            _v1246 = _v1238.height
            start = end
            end += 2
            (_v1246.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1238.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1238.height_is_present = bool(_v1238.height_is_present)
            _v1247 = _v1211.radial
            _v1248 = _v1247.shape_reference_point
            _v1249 = _v1248.x_coordinate
            start = end
            end += 2
            (_v1249.value,) = _get_struct_h().unpack(str[start:end])
            _v1250 = _v1248.y_coordinate
            start = end
            end += 2
            (_v1250.value,) = _get_struct_h().unpack(str[start:end])
            _v1251 = _v1248.z_coordinate
            start = end
            end += 2
            (_v1251.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1248.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1248.z_coordinate_is_present = bool(_v1248.z_coordinate_is_present)
            start = end
            end += 1
            (_v1247.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1247.shape_reference_point_is_present = bool(_v1247.shape_reference_point_is_present)
            _v1252 = _v1247.range
            start = end
            end += 2
            (_v1252.value,) = _get_struct_H().unpack(str[start:end])
            _v1253 = _v1247.stationary_horizontal_opening_angle_start
            start = end
            end += 2
            (_v1253.value,) = _get_struct_H().unpack(str[start:end])
            _v1254 = _v1247.stationary_horizontal_opening_angle_end
            start = end
            end += 2
            (_v1254.value,) = _get_struct_H().unpack(str[start:end])
            _v1255 = _v1247.vertical_opening_angle_start
            start = end
            end += 2
            (_v1255.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1247.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1247.vertical_opening_angle_start_is_present = bool(_v1247.vertical_opening_angle_start_is_present)
            _v1256 = _v1247.vertical_opening_angle_end
            start = end
            end += 2
            (_v1256.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1247.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1247.vertical_opening_angle_end_is_present = bool(_v1247.vertical_opening_angle_end_is_present)
            _v1257 = _v1211.radial_shapes
            _v1258 = _v1257.ref_point_id
            start = end
            end += 1
            (_v1258.value,) = _get_struct_B().unpack(str[start:end])
            _v1259 = _v1257.x_coordinate
            start = end
            end += 2
            (_v1259.value,) = _get_struct_h().unpack(str[start:end])
            _v1260 = _v1257.y_coordinate
            start = end
            end += 2
            (_v1260.value,) = _get_struct_h().unpack(str[start:end])
            _v1261 = _v1257.z_coordinate
            start = end
            end += 2
            (_v1261.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1257.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1257.z_coordinate_is_present = bool(_v1257.z_coordinate_is_present)
            _v1262 = _v1257.radial_shapes_list
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1262.array = []
            for i in range(0, length):
              val12 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
              _v1263 = val12.range
              start = end
              end += 2
              (_v1263.value,) = _get_struct_H().unpack(str[start:end])
              _v1264 = val12.horizontal_opening_angle_start
              start = end
              end += 2
              (_v1264.value,) = _get_struct_H().unpack(str[start:end])
              _v1265 = val12.horizontal_opening_angle_end
              start = end
              end += 2
              (_v1265.value,) = _get_struct_H().unpack(str[start:end])
              _v1266 = val12.vertical_opening_angle_start
              start = end
              end += 2
              (_v1266.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val12.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.vertical_opening_angle_start_is_present = bool(val12.vertical_opening_angle_start_is_present)
              _v1267 = val12.vertical_opening_angle_end
              start = end
              end += 2
              (_v1267.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val12.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
              val12.vertical_opening_angle_end_is_present = bool(val12.vertical_opening_angle_end_is_present)
              _v1262.array.append(val12)
            start = end
            end += 1
            (_v1209.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1209.cluster_bounding_box_shape_is_present = bool(_v1209.cluster_bounding_box_shape_is_present)
            _v1268 = _v1209.cluster_cardinality_size
            start = end
            end += 1
            (_v1268.value,) = _get_struct_B().unpack(str[start:end])
            _v1269 = _v1209.cluster_profiles
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v1269.value = str[start:end]
            start = end
            end += 1
            (_v1269.bits_unused,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v1209.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1209.cluster_profiles_is_present = bool(_v1209.cluster_profiles_is_present)
            _v1270 = _v1202.other_sub_class
            start = end
            end += 1
            (_v1270.value,) = _get_struct_B().unpack(str[start:end])
            _v1271 = val6.confidence
            start = end
            end += 1
            (_v1271.value,) = _get_struct_B().unpack(str[start:end])
            _v1201.array.append(val6)
          start = end
          end += 1
          (val4.classification_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.classification_is_present = bool(val4.classification_is_present)
          _v1272 = val4.map_position
          _v1273 = _v1272.map_reference
          start = end
          end += 1
          (_v1273.choice,) = _get_struct_B().unpack(str[start:end])
          _v1274 = _v1273.roadsegment
          _v1275 = _v1274.region
          start = end
          end += 2
          (_v1275.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1274.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1274.region_is_present = bool(_v1274.region_is_present)
          _v1276 = _v1274.id
          start = end
          end += 2
          (_v1276.value,) = _get_struct_H().unpack(str[start:end])
          _v1277 = _v1273.intersection
          _v1278 = _v1277.region
          start = end
          end += 2
          (_v1278.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1277.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1277.region_is_present = bool(_v1277.region_is_present)
          _v1279 = _v1277.id
          start = end
          end += 2
          (_v1279.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1272.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1272.map_reference_is_present = bool(_v1272.map_reference_is_present)
          _v1280 = _v1272.lane_id
          start = end
          end += 1
          (_v1280.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1272.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1272.lane_id_is_present = bool(_v1272.lane_id_is_present)
          _v1281 = _v1272.connection_id
          start = end
          end += 1
          (_v1281.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1272.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1272.connection_id_is_present = bool(_v1272.connection_id_is_present)
          _v1282 = _v1272.longitudinal_lane_position
          _v1283 = _v1282.longitudinal_lane_position_value
          start = end
          end += 2
          (_v1283.value,) = _get_struct_H().unpack(str[start:end])
          _v1284 = _v1282.longitudinal_lane_position_confidence
          start = end
          end += 2
          (_v1284.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1272.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1272.longitudinal_lane_position_is_present = bool(_v1272.longitudinal_lane_position_is_present)
          start = end
          end += 1
          (val4.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.map_position_is_present = bool(val4.map_position_is_present)
          _v1118.array.append(val4)
        self.cpm_containers.value.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_Q2i3Hi5BbBbB = None
def _get_struct_Q2i3Hi5BbBbB():
    global _struct_Q2i3Hi5BbBbB
    if _struct_Q2i3Hi5BbBbB is None:
        _struct_Q2i3Hi5BbBbB = struct.Struct("<Q2i3Hi5BbBbB")
    return _struct_Q2i3Hi5BbBbB
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
